VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Address"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D337901F4"
Option Base 0
Option Explicit

'##ModelId=36D239A802A8
Private maddressLine1 As String


'##ModelId=36D239BC0190
Private maddressLine2 As String


'##ModelId=36D239C7010E
Private maddressLine3 As String


'##ModelId=36D239D30276
Private mcity As String


'##ModelId=36D239DD0050
Private mstate As String


'##ModelId=36D239F900C8
Private mzip As String


'##ModelId=36D23A130154
Private maddressId As Long


'##ModelId=36FDCE7802E4
Private misDirty As Boolean


'##ModelId=36FDCE780320
Private misNew As Boolean

'##ModelId=36FDCE780352
Private misDeleted As Boolean


'##ModelId=36FBFF12012D
Public theLocale As New Collection
'##ModelId=36FDCE780390
Private theAddressDT As dtsvc.AddressDT
'##ModelId=3703E8CE0244
Public mcolAddress As New Collection
Implements ObjectControl
'##ModelId=371244DE00F2
Dim moInstanceInfo As InstanceUDT


'##ModelId=36FC036001EA
Public Property Get addressId() As Long
   Let addressId = maddressId
End Property

'##ModelId=36FC0360010E
Public Property Let addressId(ByVal Value As Long)
    Let maddressId = Value
End Property

'##ModelId=36FC036000D2
Public Property Get zip() As String
   Let zip = mzip
End Property

'##ModelId=36FC035F03DE
Public Property Let zip(ByVal Value As String)
    Let mzip = Value
End Property

'##ModelId=36FC035F0370
Public Property Get state() As String
   Let state = mstate
End Property

'##ModelId=36FC035F02D0
Public Property Let state(ByVal Value As String)
    Let mstate = Value
End Property

'##ModelId=36FC035F0262
Public Property Get city() As String
   Let city = mcity
End Property

'##ModelId=36FC035F01B8
Public Property Let city(ByVal Value As String)
    Let mcity = Value
End Property

'##ModelId=36FC035F014A
Public Property Get addressLine3() As String
   Let addressLine3 = maddressLine3
End Property

'##ModelId=36FC035F006E
Public Property Let addressLine3(ByVal Value As String)
    Let maddressLine3 = Value
End Property

'##ModelId=36FC035F000A
Public Property Get addressLine2() As String
   Let addressLine2 = maddressLine2
End Property

'##ModelId=36FC035E0348
Public Property Let addressLine2(ByVal Value As String)
    Let maddressLine2 = Value
End Property

'##ModelId=36FC035E02DA
Public Property Get addressLine1() As String
   Let addressLine1 = maddressLine1
End Property

'##ModelId=36FC035E023A
Public Property Let addressLine1(ByVal Value As String)
    Let maddressLine1 = Value
End Property
'##ModelId=36FDCE7901CC
Public Property Get isDirty() As Boolean
    isDirty = misDirty
End Property


'##ModelId=36FDCE790190
Public Property Let isDirty(ByVal Value As Boolean)
    misDirty = Value
End Property
'##ModelId=36FDCE79023A
Public Property Get isNew() As Boolean
    isNew = misNew
End Property


'##ModelId=36FDCE7901FE
Public Property Let isNew(ByVal Value As Boolean)
    misNew = Value
End Property
'##ModelId=36FDCE79026D
Public Property Get isDeleted() As Boolean
    isDeleted = misDeleted
End Property


'##ModelId=36FDCE79023B
Public Property Let isDeleted(ByVal Value As Boolean)
    misDeleted = Value
End Property
'##ModelId=36FDCE7902A8
Public Function getInfo(ByVal lAddressId As Long, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean

    On Error GoTo getInfoErr
    
    Dim sData() As String
        
    Dim oICrud As ICrud
        
    getInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theAddressDT = New dtsvc.AddressDT
    Else
        Set theAddressDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.AddressDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theAddressDT
    
    If oICrud.getInfo(CStr(lAddressId), sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          getInfo = True
          Exit Function
       End If
    End If
    
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8CF019A
Private Sub getAddressBase(sData() As String)

    ReDim sData(giAddressCount - 1, 0)

    sData(giAddressId, 0) = addressId
    sData(giAddressLine1, 0) = addressLine1
    sData(giAddressLine2, 0) = addressLine2
    sData(giAddressLine3, 0) = addressLine3
    sData(giCity, 0) = city
    sData(giState, 0) = state
    sData(giZip, 0) = zip
    sData(giAddressISNew, 0) = isNew
    sData(giAddressISDirty, 0) = isDirty
    sData(giAddressISDeleted, 0) = isDeleted
End Sub
'##ModelId=36FDCE7902DB
Public Function getState(SGetAddress() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
    Dim i As Integer
            
    ReDim SGetAddress(giAddressCount - 1, 0)
    
    SGetAddress(giAddressId, 0) = addressId
    SGetAddress(giAddressLine1, 0) = addressLine1
    SGetAddress(giAddressLine2, 0) = addressLine2
    SGetAddress(giAddressLine3, 0) = addressLine3
    SGetAddress(giCity, 0) = city
    SGetAddress(giState, 0) = state
    SGetAddress(giZip, 0) = zip
    SGetAddress(giAddressISDeleted, 0) = isDeleted
    SGetAddress(giAddressISNew, 0) = isNew
    SGetAddress(giAddressISDirty, 0) = isDirty
    
    getState = True
    Exit Function

getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8CF0208
Public Function saveInfo(Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo saveInfoErr
    
    Dim oICrud As ICrud
    Dim sAddressData() As String
       
    saveInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theAddressDT = New dtsvc.AddressDT
    Else
        Set theAddressDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.AddressDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theAddressDT
    
    'get address information into an array to send onward
    getAddressBase sAddressData
    
    'Depending on internal state, the correct message is invoked
    If isNew Then
       If oICrud.Insert("", sAddressData, sConnect, lErrno, sErrDescr) Then
          saveInfo = True
          Exit Function
       End If
    Else
       If isDirty Then
          If oICrud.Update("", sAddressData, sConnect, lErrno, sErrDescr) Then
             saveInfo = True
             Exit Function
          End If
       Else
          If isDeleted Then
             If oICrud.Delete("", sAddressData, sConnect, lErrno, sErrDescr) Then
                saveInfo = True
                Exit Function
             End If
          End If
       End If
    End If
    
    Exit Function
    
saveInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8CF023A
Public Function setState(sAddressData() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo setStateErr
        
    setState = False
    Dim iIndex As Integer
    Dim oAddress As Address
    
    'No address records, get out
    If sAddressData(giZERODIM, giZERODIM) = "" Then
        setState = True
        Exit Function
    End If
    
    For iIndex = LBound(sAddressData, giTWODIM) To UBound(sAddressData, giTWODIM)
        If moInstanceInfo.objectContext Is Nothing Then
            Set oAddress = New Address
        Else
            Set oAddress = moInstanceInfo.objectContext.CreateInstance("brsvc.Address")
        End If
                     
        If oAddress.unPack(sAddressData, iIndex, False) Then
           Me.mcolAddress.Add oAddress, CStr(oAddress.addressId)
           setState = True
        End If
    Next
    
    Exit Function

setStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36FDCE790348
Public Function unPack(sData() As String, iIndex As Integer, Optional ByVal bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    addressId = CLng(sData(giAddressId, iIndex))
    addressLine1 = CStr(sData(giAddressLine1, iIndex))
    addressLine2 = CStr(sData(giAddressLine2, iIndex))
    addressLine3 = CStr(sData(giAddressLine3, iIndex))
    city = CStr(sData(giCity, iIndex))
    state = CStr(sData(giState, iIndex))
    zip = CStr(sData(giZip, iIndex))
    
    If bInquiry Then
        isDeleted = False
        isNew = False
        isDirty = False
    Else
        isDeleted = CBool(sData(giAddressISDeleted, iIndex))
        isNew = CBool(sData(giAddressISNew, iIndex))
        isDirty = CBool(sData(giAddressISDirty, iIndex))
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36FDCE790384
Private Sub Class_Terminate()
    Set theAddressDT = Nothing
End Sub
'##ModelId=371244DF0186
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=371244DF01C2
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=371244DF01F4
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
