VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Customer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"366DCC37023A"
Option Base 0
Option Explicit

'##ModelId=36D23FF70032
Private mcustomerId As Long

'##ModelId=36CB07180334
Private mcustomerNumber As String

'##ModelId=36CB066B0168
Private mfirstName As String

'##ModelId=36CB067801AE
Private mlastName As String

'##ModelId=36CB068E02A8
Private mmiddleInitial As String

'##ModelId=36CB06A302D0
Private mprefix As String

'##ModelId=36CB06AD0032
Private msuffix As String

'##ModelId=36F08C10023A
Private mphone1 As String

'##ModelId=36F08C200302
Private mphone2 As String

'##ModelId=36F08C2D0082
Private meMail As String

'##ModelId=36D5579E01AE
Private misDirty As Boolean

'##ModelId=36D557A802EE
Private misNew As Boolean

'##ModelId=36FDCE8602EE
Private misDeleted As Boolean

'##ModelId=36CB1D4600BE
Public theOrder As New Collection

'##ModelId=36FBFF15028B
Public theLocale As New Collection

'##ModelId=36F73627002A
Private theCustomerDT As dtsvc.CustomerDT
Implements ObjectControl
'##ModelId=37124523003C
Dim moInstanceInfo As InstanceUDT


'##ModelId=36F1EBC30029
Public Property Get eMail() As String
   Let eMail = meMail
End Property

'##ModelId=36F1EBC203DE
Public Property Let eMail(ByVal Value As String)
    Let meMail = Value
End Property

'##ModelId=36F1EBC203A3
Public Property Get phone2() As String
   Let phone2 = mphone2
End Property

'##ModelId=36F1EBC20370
Public Property Let phone2(ByVal Value As String)
    Let mphone2 = Value
End Property

'##ModelId=36F1EBC20335
Public Property Get phone1() As String
   Let phone1 = mphone1
End Property

'##ModelId=36F1EBC20302
Public Property Let phone1(ByVal Value As String)
    Let mphone1 = Value
End Property

'##ModelId=36F1EBC202C8
Public Property Get isNew() As Boolean
   Let isNew = misNew
End Property

'##ModelId=36F1EBC202C6
Public Property Let isNew(ByVal Value As Boolean)
    Let misNew = Value
End Property

'##ModelId=36F1EBC20294
Public Property Get isDirty() As Boolean
   Let isDirty = misDirty
End Property

'##ModelId=36F1EBC20258
Public Property Let isDirty(ByVal Value As Boolean)
    Let misDirty = Value
End Property

'##ModelId=36FDCE8701CC
Public Property Get isDeleted() As Boolean
   Let isDeleted = misDeleted
End Property


'##ModelId=36FDCE87015E
Public Property Let isDeleted(ByVal Value As Boolean)
    Let misDeleted = Value
End Property

'##ModelId=36F1EBC20226
Public Property Get suffix() As String
   Let suffix = msuffix
End Property

'##ModelId=36F1EBC201EA
Public Property Let suffix(ByVal Value As String)
    Let msuffix = Value
End Property

'##ModelId=36F1EBC201B8
Public Property Get prefix() As String
   Let prefix = mprefix
End Property

'##ModelId=36F1EBC2017C
Public Property Let prefix(ByVal Value As String)
    Let mprefix = Value
End Property

'##ModelId=36F1EBC2014B
Public Property Get middleInitial() As String
   Let middleInitial = mmiddleInitial
End Property

'##ModelId=36F1EBC2010E
Public Property Let middleInitial(ByVal Value As String)
    Let mmiddleInitial = Value
End Property

'##ModelId=36F1EBC200DE
Public Property Get lastName() As String
   Let lastName = mlastName
End Property

'##ModelId=36F1EBC200DC
Public Property Let lastName(ByVal Value As String)
    Let mlastName = Value
End Property

'##ModelId=36F1EBC200A0
Public Property Get firstName() As String
   Let firstName = mfirstName
End Property

'##ModelId=36F1EBC2006E
Public Property Let firstName(ByVal Value As String)
    Let mfirstName = Value
End Property

'##ModelId=36F1EBC20032
Public Property Get customerNumber() As String
   Let customerNumber = mcustomerNumber
End Property

'##ModelId=36F1EBC20000
Public Property Let customerNumber(ByVal Value As String)
    Let mcustomerNumber = Value
End Property

'##ModelId=36F1EBC103AE
Public Property Get customerId() As Long
   Let customerId = mcustomerId
End Property

'##ModelId=36F1EBC103AC
Public Property Let customerId(ByVal Value As Long)
    Let mcustomerId = Value
End Property
'##ModelId=36F71FD80334
Public Function getInfo(ByVal sCustomerNumber As String, Optional bExpand As Boolean, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoErr
    
    Dim sData() As String
    
    Dim oICrud As ICrud
    Dim oLocale As Locale
    
    getInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theCustomerDT = New dtsvc.CustomerDT
    Else
        Set theCustomerDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.CustomerDT")
    End If
    
        
    'Talk to the DT interface
    Set oICrud = theCustomerDT
    
    If oICrud.getInfo(sCustomerNumber, sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          getInfo = True
          If bExpand Then
             If moInstanceInfo.objectContext Is Nothing Then
                Set oLocale = New Locale
             Else
                Set oLocale = moInstanceInfo.objectContext.CreateInstance("brsvc.Locale")
             End If
            
             Set oLocale.theCustomer = Me
             If oLocale.getInfoByCustomerId(sConnect, lErrno, sErrDescr) Then
                Set theLocale = oLocale.colLocale
            End If
          End If
       End If
    End If
    
    Exit Function
      
        
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726705C017C
Public Function getInfoById(ByVal lCustomerId As Long, Optional bExpand As Boolean, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoByIdErr
    
    Dim sData() As String
    Dim oLocale As Locale
    
    getInfoById = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theCustomerDT = New dtsvc.CustomerDT
    Else
        Set theCustomerDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.CustomerDT")
    End If
            
    If theCustomerDT.getInfoById(lCustomerId, sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          getInfoById = True
          If bExpand Then
             If moInstanceInfo.objectContext Is Nothing Then
                Set oLocale = New Locale
             Else
                Set oLocale = moInstanceInfo.objectContext.CreateInstance("brsvc.Locale")
             End If
            
             Set oLocale.theCustomer = Me
             If oLocale.getInfoByCustomerId(sConnect, lErrno, sErrDescr) Then
                Set theLocale = oLocale.colLocale
            End If
          End If
       End If
    End If
    
    Exit Function
      
        
getInfoByIdErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36F71FD803A2
Public Function getState(sData() As String, sDataLocale() As String, sDataAddress() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
    Dim i As Integer
    Dim sGetLocale() As String
    Dim SGetAddress() As String
        
    
    ReDim sDataLocale(giLocaleCount - 1, 0)
    ReDim sDataAddress(giAddressCount - 1, 0)
        
    'get just the customer base information
    getCustomerBase sData
        
    For i = 1 To theLocale.Count
        If theLocale(i).getState(sGetLocale, SGetAddress, lErrno, sErrDescr) Then
           ReDim Preserve sDataLocale(giLocaleCount - 1, i - 1)
           
           sDataLocale(giLocaleId, i - 1) = sGetLocale(giLocaleId, 0)
           sDataLocale(giLocaleCustomerId, i - 1) = sGetLocale(giLocaleCustomerId, 0)
           sDataLocale(giLocaleAddressId, i - 1) = sGetLocale(giLocaleAddressId, 0)
           sDataLocale(giRole, i - 1) = sGetLocale(giRole, 0)
           sDataLocale(giLocaleISDeleted, i - 1) = sGetLocale(giLocaleISDeleted, 0)
           sDataLocale(giLocaleISNew, i - 1) = sGetLocale(giLocaleISNew, 0)
           sDataLocale(giLocaleISDirty, i - 1) = sGetLocale(giLocaleISDirty, 0)
           
           ReDim sGetLocale(0, 0)
           
           ReDim Preserve sDataAddress(giAddressCount - 1, i - 1)
           
           sDataAddress(giAddressId, i - 1) = SGetAddress(giAddressId, 0)
           sDataAddress(giAddressLine1, i - 1) = SGetAddress(giAddressLine1, 0)
           sDataAddress(giAddressLine2, i - 1) = SGetAddress(giAddressLine2, 0)
           sDataAddress(giAddressLine3, i - 1) = SGetAddress(giAddressLine3, 0)
           sDataAddress(giCity, i - 1) = SGetAddress(giCity, 0)
           sDataAddress(giState, i - 1) = SGetAddress(giState, 0)
           sDataAddress(giZip, i - 1) = SGetAddress(giZip, 0)
           sDataAddress(giAddressISDeleted, i - 1) = SGetAddress(giAddressISDeleted, 0)
           sDataAddress(giAddressISNew, i - 1) = SGetAddress(giAddressISNew, 0)
           sDataAddress(giAddressISDirty, i - 1) = SGetAddress(giAddressISDirty, 0)
           
           ReDim SGetAddress(0, 0)
           
        End If
    Next i
    
    
    getState = True
    Exit Function

getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8DD01D6
Private Sub getCustomerBase(sData() As String)

    ReDim sData(giCustomerCount - 1, 0)

    sData(giCustomerId, 0) = customerId
    sData(giCustomerNumber, 0) = customerNumber
    sData(giFirstName, 0) = firstName
    sData(giLastName, 0) = lastName
    sData(giMiddleInitial, 0) = middleInitial
    sData(giPrefix, 0) = prefix
    sData(giSuffix, 0) = suffix
    sData(giPhone1, 0) = phone1
    sData(giPhone2, 0) = phone2
    sData(giEMail, 0) = eMail
    sData(giCustomerISNew, 0) = isNew
    sData(giCustomerISDirty, 0) = isDirty
    sData(giCustomerISDeleted, 0) = isDeleted
End Sub

'##ModelId=3703E8DD0244
Public Function saveInfo(Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo saveInfoErr
    
    Dim iIndex As Integer
    Dim oICrud As ICrud
    Dim sCustomerData() As String
       
    saveInfo = False
    
      
   If moInstanceInfo.objectContext Is Nothing Then
        Set theCustomerDT = New dtsvc.CustomerDT
    Else
        Set theCustomerDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.CustomerDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theCustomerDT
    
    'get customer information into an array to send onward
    getCustomerBase sCustomerData
    
    'Depending on internal state, the correct message is invoked
    If isNew Then
       If oICrud.Insert("", sCustomerData, sConnect, lErrno, sErrDescr) Then
          saveInfo = True
         
       End If
    Else
       If isDirty Then
          If oICrud.Update("", sCustomerData, sConnect, lErrno, sErrDescr) Then
             saveInfo = True
             
          End If
       Else
          If isDeleted Then
             If oICrud.Delete("", sCustomerData, sConnect, lErrno, sErrDescr) Then
                saveInfo = True
                
             End If
          End If
       End If
    End If
    
    For iIndex = 1 To theLocale.Count
        If theLocale(iIndex).saveInfo(sConnect, lErrno, sErrDescr) Then
           saveInfo = True
        End If
    Next
    
    Exit Function
    
saveInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8DD0276
Public Function setState(sCustomerData() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo setStateErr
        
    Dim i As Integer
            
    setState = False
        
    If sCustomerData(giCustomerISNew, 0) = True Or sCustomerData(giCustomerISDeleted, 0) = True Or sCustomerData(giCustomerISDirty, 0) = True Then
        If unPack(sCustomerData, giZERODIM, False) Then
        
           setState = True
           
        End If
        setState = True
    End If
    
        
    Exit Function

setStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36F71FD803D5
Private Function unPack(sData() As String, iIndex As Integer, Optional bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    customerId = CLng(sData(giCustomerId, iIndex))
    customerNumber = CStr(sData(giCustomerNumber, iIndex))
    firstName = CStr(sData(giFirstName, iIndex))
    lastName = CStr(sData(giLastName, iIndex))
    middleInitial = CStr(sData(giMiddleInitial, iIndex))
    prefix = CStr(sData(giPrefix, iIndex))
    suffix = CStr(sData(giSuffix, iIndex))
    phone1 = CStr(sData(giPhone1, iIndex))
    phone2 = CStr(sData(giPhone2, iIndex))
    eMail = CStr(sData(giEMail, iIndex))
    
    
    'If the unpack is the result of an inquiry then default
    'the state flags to false, else...use what was passed in
    'from the client
    If bInquiry Then
       isDeleted = False
       isNew = False
       isDirty = False
    Else
       isDeleted = sData(giCustomerISDeleted, iIndex)
       isNew = sData(giCustomerISNew, iIndex)
       isDirty = sData(giCustomerISDirty, iIndex)
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36F7362803C0
Private Sub Class_Terminate()
    Set theCustomerDT = Nothing
End Sub
'##ModelId=3712452501A4
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3712452501E0
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3712452501E1
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

