VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Dictionary"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3700047703C0"
Public Type AddressUDT
    addressId As Long
    addressLine1 As String
    addressLine2 As String
    addressLine3 As String
    city As String
    state As String
    zip As String
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumAddress
    giAddressCount = 10
    giAddressId = 0
    giAddressLine1 = 1
    giAddressLine2 = 2
    giAddressLine3 = 3
    giCity = 4
    giState = 5
    giZip = 6
    giAddressISDeleted = 7
    giAddressISNew = 8
    giAddressISDirty = 9
End Enum

Public Type CustomerUDT
    customerId As Long
    customerNumber As String
    firstName As String
    lastName As String
    middleInitial As String
    prefix As String
    suffix As String
    phone1 As String
    phone2 As String
    eMail As String
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumCustomer
    giCustomerCount = 13
    giCustomerId = 0
    giCustomerNumber = 1
    giFirstName = 2
    giLastName = 3
    giMiddleInitial = 4
    giPrefix = 5
    giSuffix = 6
    giPhone1 = 7
    giPhone2 = 8
    giEMail = 9
    giCustomerISDeleted = 10
    giCustomerISNew = 11
    giCustomerISDirty = 12
End Enum

Public Type LocaleUDT
    localeId As Long
    customerId As Long
    addressId As Long
    role As Integer
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumLocale
    giLocaleCount = 7
    giLocaleId = 0
    giLocaleCustomerId = 1
    giLocaleAddressId = 2
    giRole = 3
    giLocaleISDeleted = 4
    giLocaleISNew = 5
    giLocaleISDirty = 6
End Enum

Public Type OrderUDT
    orderId As Long
    orderNumber As String
    invoiceId As Long
    customerId As Long
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumOrder
    giOrderCount = 7
    giOrderId = 0
    giOrderNumber = 1
    giInvoiceId = 2
    giOrderCustomerId = 3
    giOrderISDeleted = 4
    giOrderISNew = 5
    giOrderISDirty = 6
End Enum

Public Type OrderSummaryUDT
    orderSummaryId As Long
    orderId As Long
    discount As Currency
    courtesyMessage As String
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumOrderSummary
    giOrderSummaryCount = 7
    giOrderSummaryId = 0
    giOrderSummaryOrderId = 1
    giDiscount = 2
    giCourtesyMessage = 3
    giOrderSummaryISDeleted = 4
    giOrderSummaryISNew = 5
    giOrderSummaryISDirty = 6
End Enum

Public Type OrderLineUDT
    orderLineId As Long
    orderId As Long
    productId As Long
    quantity As Integer
    discount As Currency
    unitPrice As Currency
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumOrderLine
    giOrderLineCount = 9
    giOrderLineId = 0
    giOrderLineOrderId = 1
    giOrderLineProductId = 2
    giQuantity = 3
    giOrderLineDiscount = 4
    giUnitPrice = 5
    giOrderLineISDeleted = 6
    giOrderLineISNew = 7
    giOrderLineISDirty = 8
End Enum

Public Type OrderHeaderUDT
    orderHeaderId As Long
    orderId As Long
    date As Date
    terms As String
    salesPerson As String
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumOrderHeader
    giOrderHeaderCount = 8
    giOrderHeaderId = 0
    giOrderHeaderOrderId = 1
    giDate = 2
    giTerms = 3
    giSalesPerson = 4
    giOrderHeaderISDeleted = 5
    giOrderHeaderISNew = 6
    giOrderHeaderISDirty = 7
End Enum

Public Type ProductUDT
    productId As Long
    description As String
    price As Currency
    discount As Currency
    quantityOnHand As Integer
    eoq As Integer
    productType As Integer
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumProduct
    giProductCount = 10
    giProductId = 0
    giProductDescription = 1
    giPrice = 2
    giProductDiscount = 3
    giQuantityOnHand = 4
    giEoq = 5
    giProductType = 6
    giProductISDeleted = 7
    giProductISNew = 8
    giProductISDirty = 9
End Enum

'Guitar is the concatenation of product and Guitar
Public Type GuitarUDT
    stringCount As Integer
    right As String
    fretLess As String
    make As String
    model As String
    age As Integer
    guitarId As Long
    productId As Long
    description As String
    price As Currency
    discount As Currency
    quantityOnHand As Integer
    eoq As Integer
    productType As Integer
End Type

Public Enum enumGuitar
    giGuitarCount = 17
    giStringCount = 0
    giRight = 1
    giFretLess = 2
    giMake = 3
    giModel = 4
    giAge = 5
    giGuitarId = 6
    giGuitarProductId = 7
    giGuitarDescription = 8
    giGuitarPrice = 9
    giGuitarDiscount = 10
    giGuitarQuantityOnHand = 11
    giGuitarEoq = 12
    giGuitarProductType = 13
    giGuitarISDeleted = 14
    giGuitarISNew = 15
    giGuitarISDirty = 16
End Enum

'Sheet is the concatenation of product and sheet
Public Type SheetMusicUDT
    pages As Integer
    sheetMusicId As Long
    productId As Long
    description As String
    price As Currency
    discount As Currency
    quantityOnHand As Integer
    eoq As Integer
    productType As Integer
End Type

Public Enum enumSheetMusic
    giSheetMusicCount = 12
    giPages = 0
    giSheetMusicId = 1
    giSheetMusicProductId = 2
    giSheetMusicDescription = 3
    giSheetMusicPrice = 4
    giSheetMusicDiscount = 5
    giSheetMusicQuantityOnHand = 6
    giSheetMusicEoq = 7
    giSheetMusicProductType = 8
    giSheetMusicISDeleted = 9
    giSheetMusicISNew = 10
    giSheetMusicISDirty = 11
End Enum

'Supplies is the concatenation of product and supplies
Public Type SuppliesUDT
    independent As String
    supplyId As Long
    productId As Long
    description As String
    price As Currency
    discount As Currency
    quantityOnHand As Integer
    eoq As Integer
    productType As Integer
End Type

Public Enum enumSupplies
    giSuppliesCount = 12
    giIndependent = 0
    giSupplyId = 1
    giSupplyProductId = 2
    giSuppliesDescription = 3
    giSuppliesPrice = 4
    giSuppliesDiscount = 5
    giSuppliesQuantityOnHand = 6
    giSuppliesEoq = 7
    giSuppliesProductType = 8
    giSuppliesISDeleted = 9
    giSuppliesISNew = 10
    giSuppliesISDirty = 11
End Enum


Public Type SysCodeUDT
    sysCodeId As Long
    name As String
    code As String
    description As String
    isDeleted As Boolean
    isNew As Boolean
    isDirty As Boolean
End Type

Public Enum enumSysCode
    giSysCodeCount = 7
    giSysCodeId = 0
    giName = 1
    giCode = 2
    giDescription = 3
    giSysCodeISDeleted = 4
    giSysCodeISNew = 5
    giSysCodeISDirty = 6
End Enum

Public Enum enumProductType
    giTypeGuitar = 1
    giTypeSheetMusic = 2
    giTypeSupplies = 3
End Enum

Public Enum enumArrayOffsets
    giZERODIM = 0
    giONEDIM = 1
    giTWODIM = 2
    giTHREEDIM = 3
    giFOURDIM = 4
    giFIVEDIM = 5
End Enum

