VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "OrderHeader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D331A0398"
Option Base 0
Option Explicit

'##ModelId=36E0C6E90190
Private morderDateTime As Date

'##ModelId=36E0C6FC0122
Private mterms As String

'##ModelId=36E0C71B00A0
Private msalesPerson As String

'##ModelId=37125EC70096
Private morderHeaderId As Long

'##ModelId=3712B8BC0028
Private misNew As Boolean

'##ModelId=3712B8BC005A
Private misDirty As Boolean

'##ModelId=3712B8BC0096
Private misDeleted As Boolean

'##ModelId=368D33410172
Public theOrder As Order
'##ModelId=3726708103B8
Private theOrderHeaderDT As dtsvc.OrderHeaderDT
Implements ObjectControl

'##ModelId=37267082000C
Dim moInstanceInfo As InstanceUDT

'##ModelId=3712CEE70140
Public Property Get isDeleted() As Boolean
   Let isDeleted = misDeleted
End Property

'##ModelId=3712CEE70064
Public Property Let isDeleted(ByVal Value As Boolean)
    Let misDeleted = Value
End Property

'##ModelId=3712CEE603DE
Public Property Get isDirty() As Boolean
   Let isDirty = misDirty
End Property

'##ModelId=3712CEE6033E
Public Property Let isDirty(ByVal Value As Boolean)
    Let misDirty = Value
End Property

'##ModelId=3712CEE602D0
Public Property Get isNew() As Boolean
   Let isNew = misNew
End Property

'##ModelId=3712CEE601F4
Public Property Let isNew(ByVal Value As Boolean)
    Let misNew = Value
End Property

'##ModelId=3712CEE60186
Public Property Get orderHeaderId() As Long
   Let orderHeaderId = morderHeaderId
End Property

'##ModelId=3712CEE600AA
Public Property Let orderHeaderId(ByVal Value As Long)
    Let morderHeaderId = Value
End Property

'##ModelId=3712CEE6003C
Public Property Get salesPerson() As String
   Let salesPerson = msalesPerson
End Property

'##ModelId=3712CEE50348
Public Property Let salesPerson(ByVal Value As String)
    Let msalesPerson = Value
End Property

'##ModelId=3712CEE502DA
Public Property Get terms() As String
   Let terms = mterms
End Property

'##ModelId=3712CEE501FE
Public Property Let terms(ByVal Value As String)
    Let mterms = Value
End Property

'##ModelId=3712CEE50190
Public Property Get orderDateTime() As Date
   Let orderDateTime = morderDateTime
End Property

'##ModelId=3712CEE500B4
Public Property Let orderDateTime(ByVal Value As Date)
    Let morderDateTime = Value
End Property
'##ModelId=372670820230
Public Function getInfoByOrderId(ByVal lOrderId As Long, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoByOrderIdErr
    
    Dim sData() As String
    
    getInfoByOrderId = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theOrderHeaderDT = New dtsvc.OrderHeaderDT
    Else
        Set theOrderHeaderDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.OrderHeaderDT")
    End If
    
    If theOrderHeaderDT.getInfoByOrderId(lOrderId, sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          getInfoByOrderId = True
          
       End If
    End If
    
    Exit Function
      
        
getInfoByOrderIdErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=372670820262
Public Function getState(sGetOrderHeader() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
    Dim i As Integer
            
    ReDim sGetOrderHeader(giOrderHeaderCount - 1, 0)
    
    sGetOrderHeader(giOrderHeaderId, 0) = orderHeaderId
    sGetOrderHeader(giOrderHeaderOrderId, 0) = theOrder.orderId
    sGetOrderHeader(giDate, 0) = orderDateTime
    sGetOrderHeader(giTerms, 0) = terms
    sGetOrderHeader(giSalesPerson, 0) = salesPerson
    sGetOrderHeader(giOrderHeaderISDeleted, 0) = isDeleted
    sGetOrderHeader(giOrderHeaderISNew, 0) = isNew
    sGetOrderHeader(giOrderHeaderISDirty, 0) = isDirty
    
    getState = True
    Exit Function

getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=37267082029E
Private Function unPack(sData() As String, iIndex As Integer, Optional bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    orderHeaderId = CLng(sData(giOrderHeaderId, iIndex))
    orderDateTime = CDate(sData(giDate, iIndex))
    terms = CStr(sData(giTerms, iIndex))
    salesPerson = CStr(sData(giSalesPerson, iIndex))
       
    'If the unpack is the result of an inquiry then default
    'the state flags to false, else...use what was passed in
    'from the client
    If bInquiry Then
       isDeleted = False
       isNew = False
       isDirty = False
    Else
       isDeleted = sData(giOrderHeaderISDeleted, iIndex)
       isNew = sData(giOrderHeaderISNew, iIndex)
       isDirty = sData(giOrderHeaderISDirty, iIndex)
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=372670820302
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=372670820303
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=37267082033E
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

