VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Supplies"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D33D30168"
Option Base 0
Option Explicit
Implements Product

'local superclass object (generated)
'##ModelId=36E556C8012C
Private mProductObject As New Product

'##ModelId=371261960122
Private msupplyId As Long

'##ModelId=371262040280
Private mindependent As String
'##ModelId=3726707C01CC
Private theSuppliesDT As dtsvc.SuppliesDT
Implements ObjectControl

'##ModelId=3726707C01CF
Dim moInstanceInfo As InstanceUDT



'##ModelId=3726707C01FE
Private Property Let Product_productType(ByVal RHS As Integer)
    mProductObject.productType = RHS
End Property

'##ModelId=3726707C0200
Private Property Get Product_productType() As Integer
    Product_productType = mProductObject.productType()
End Property


'##ModelId=3712CEE1033E
Private Property Set Product_theProduct2(ByVal RHS As Product)
    Set mProductObject.theProduct2 = RHS
End Property

'##ModelId=3712CEE102D0
Private Property Get Product_theProduct2() As Product
    Set Product_theProduct2 = mProductObject.theProduct2
End Property

'##ModelId=3712CEE10230
Private Property Let Product_theProduct2(RHS As Variant)
    Let mProductObject.theProduct2 = RHS
End Property

'##ModelId=3712CEE101C2
Private Property Get Product_isDeleted() As Boolean
    Product_isDeleted = mProductObject.isDeleted()
End Property

'##ModelId=3712CEE100E6
Private Property Let Product_isDeleted(ByVal Value As Boolean)
    mProductObject.isDeleted = Value
End Property

'##ModelId=3712CEE100AA
Private Property Get Product_isDirty() As Boolean
    Product_isDirty = mProductObject.isDirty()
End Property

'##ModelId=3712CEE003B6
Private Property Let Product_isDirty(ByVal Value As Boolean)
    mProductObject.isDirty = Value
End Property

'##ModelId=3712CEE00384
Private Property Get Product_isNew() As Boolean
    Product_isNew = mProductObject.isNew()
End Property

'##ModelId=3712CEE002A8
Private Property Let Product_isNew(ByVal Value As Boolean)
    mProductObject.isNew = Value
End Property

'##ModelId=3712CEE0026C
Private Property Get Product_eoq() As Integer
    Product_eoq = mProductObject.eoq()
End Property

'##ModelId=3712CEE00190
Private Property Let Product_eoq(ByVal Value As Integer)
    mProductObject.eoq = Value
End Property

'##ModelId=3712CEE0015E
Private Property Get Product_quantityOnHand() As Integer
    Product_quantityOnHand = mProductObject.quantityOnHand()
End Property

'##ModelId=3712CEE00082
Private Property Let Product_quantityOnHand(ByVal Value As Integer)
    mProductObject.quantityOnHand = Value
End Property

'##ModelId=3712CEE00046
Private Property Get Product_discount() As Currency
    Product_discount = mProductObject.discount()
End Property

'##ModelId=3712CEDF038E
Private Property Let Product_discount(ByVal Value As Currency)
    mProductObject.discount = Value
End Property

'##ModelId=3712CEDF02B2
Private Property Get Product_price() As Currency
    Product_price = mProductObject.price()
End Property

'##ModelId=3712CEDF0208
Private Property Let Product_price(ByVal Value As Currency)
    mProductObject.price = Value
End Property

'##ModelId=3712CEDF019A
Private Property Get Product_description() As String
    Product_description = mProductObject.description()
End Property

'##ModelId=3712CEDF00FA
Private Property Let Product_description(ByVal Value As String)
    mProductObject.description = Value
End Property

'##ModelId=3712CEDF008C
Private Property Get Product_productId() As Long
    Product_productId = mProductObject.productId()
End Property

'##ModelId=3712CEDE0398
Private Property Let Product_productId(ByVal Value As Long)
    mProductObject.productId = Value
End Property

'##ModelId=3712CEDE021C
Public Property Get independent() As String
   Let independent = mindependent
End Property

'##ModelId=3712CEDE0172
Public Property Let independent(ByVal Value As String)
    Let mindependent = Value
End Property

'##ModelId=3712CEDE0104
Public Property Get supplyId() As Long
   Let supplyId = msupplyId
End Property

'##ModelId=3712CEDE0064
Public Property Let supplyId(ByVal Value As Long)
    Let msupplyId = Value
End Property

'##ModelId=3712CEDD03DE
Public Property Get ProductObject() As Product
    Set ProductObject = mProductObject
End Property

'##ModelId=3712CEDD0334
Public Property Set ProductObject(ByVal Value As Product)
    Set mProductObject = Value
End Property

'##ModelId=3712CEDD0294
Public Property Let ProductObject(ByVal Value As Product)
    Let mProductObject = Value
End Property

'##ModelId=3726707D0230
Private Function Product_getInfo(ByVal lProductId As Long, Optional ByVal sConnect As String, Optional oRealProduct As Object, Optional lErrno As Long, Optional sErrDescr As String) As Boolean

    On Error GoTo getInfoErr
    
    Dim sData() As String
        
    Dim oICrud As ICrud
        
    Product_getInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theSuppliesDT = New dtsvc.SuppliesDT
    Else
        Set theSuppliesDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.SuppliesDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theSuppliesDT
    
    If oICrud.getInfo(CStr(lProductId), sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          Product_getInfo = True
          Exit Function
       End If
    End If
    
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726707D029E
Private Function unPack(sData() As String, iIndex As Integer, Optional bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    
    independent = CStr(sData(giIndependent, iIndex))
    supplyId = CLng(sData(giSupplyId, iIndex))
    
    'set superclass values
    Product_productId = CLng(sData(giSupplyProductId, iIndex))
    Product_description = CStr(sData(giSuppliesDescription, iIndex))
    Product_price = CCur(sData(giSuppliesPrice, iIndex))
    Product_discount = CCur(sData(giSuppliesDiscount, iIndex))
    Product_quantityOnHand = CInt(sData(giSuppliesQuantityOnHand, iIndex))
    Product_eoq = CInt(sData(giSuppliesEoq, iIndex))
    Product_productType = CLng(sData(giSuppliesProductType, iIndex))
    
    'If the unpack is the result of an inquiry then default
    'the state flags to false, else...use what was passed in
    'from the client
    If bInquiry Then
       Product_isDeleted = False
       Product_isNew = False
       Product_isDirty = False
    Else
       Product_isDeleted = sData(giSuppliesISDeleted, iIndex)
       Product_isNew = sData(giSuppliesISNew, iIndex)
       Product_isDirty = sData(giSuppliesISDirty, iIndex)
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726707D030C
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=3726707D030D
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=3726707D033E
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

