VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "SysCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36FDD105032A"
Option Base 0
Option Explicit

'##ModelId=36FDD11E0352
Private mname As String

'##ModelId=36FDD15B03D4
Private msysCodeId As Long

'##ModelId=36FDD18B03DE
Private mcode As String

'##ModelId=36FDD1D3029E
Private mdescription As String

'##ModelId=36FDD462006E
Private misNew As Boolean

'##ModelId=36FDD47802E4
Private misDirty As Boolean

'##ModelId=36FDD4940244
Private misDeleted As Boolean
'##ModelId=3700047803AC
Private mcolSysCode As Collection
'##ModelId=370004790002
Private theSysCodeDT As dtsvc.SysCodeDT
Implements ObjectControl
'##ModelId=3712453700A2
Dim moInstanceInfo As InstanceUDT


'##ModelId=36FDD4DB0034
Public Property Get isDeleted() As Boolean
   Let isDeleted = misDeleted
End Property

'##ModelId=36FDD4DB0032
Public Property Let isDeleted(ByVal Value As Boolean)
    Let misDeleted = Value
End Property

'##ModelId=36FDD4DB0002
Public Property Get isDirty() As Boolean
   Let isDirty = misDirty
End Property

'##ModelId=36FDD4DB0000
Public Property Let isDirty(ByVal Value As Boolean)
    Let misDirty = Value
End Property

'##ModelId=36FDD4DA03AE
Public Property Get isNew() As Boolean
   Let isNew = misNew
End Property

'##ModelId=36FDD4DA03AC
Public Property Let isNew(ByVal Value As Boolean)
    Let misNew = Value
End Property

'##ModelId=36FDD2DE0304
Public Property Get description() As String
   Let description = mdescription
End Property

'##ModelId=36FDD2DE0302
Public Property Let description(ByVal Value As String)
    Let mdescription = Value
End Property

'##ModelId=36FDD2DE02C8
Public Property Get code() As String
   Let code = mcode
End Property

'##ModelId=36FDD2DE02C6
Public Property Let code(ByVal Value As String)
    Let mcode = Value
End Property

'##ModelId=36FDD2DE0296
Public Property Get sysCodeId() As Long
   Let sysCodeId = msysCodeId
End Property

'##ModelId=36FDD2DE0294
Public Property Let sysCodeId(ByVal Value As Long)
    Let msysCodeId = Value
End Property

'##ModelId=36FDD2DE0262
Public Property Get name() As String
   Let name = mname
End Property

'##ModelId=36FDD2DE0226
Public Property Let name(ByVal Value As String)
    Let mname = Value
End Property
'##ModelId=370004790258
Public Function getInfo(ByVal sName As String, Optional bExpand As Boolean, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoErr
    
    Dim sData() As String
    
    Dim oICrud As ICrud
        
    getInfo = False
    
    'MTS Check
    If moInstanceInfo.objectContext Is Nothing Then
       Set theSysCodeDT = New dtsvc.SysCodeDT
    Else 'MTS present
       Set theSysCodeDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.SysCodeDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theSysCodeDT
    
    If oICrud.getInfo(sName, sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM) Then
          getInfo = True
          Exit Function
       End If
    End If
    
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=370004790294
Public Function getState(sData() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
    Dim i As Integer
    
    ReDim sData(giSysCodeCount - 1, 0)
            
    For i = 1 To mcolSysCode.Count
    
        ReDim Preserve sData(giSysCodeCount - 1, i - 1)
        
        sData(giSysCodeId, i - 1) = mcolSysCode(i).sysCodeId
        sData(giName, i - 1) = mcolSysCode(i).name
        sData(giCode, i - 1) = mcolSysCode(i).code
        sData(giDescription, i - 1) = mcolSysCode(i).description
        sData(giSysCodeISNew, i - 1) = mcolSysCode(i).isNew
        sData(giSysCodeISDirty, i - 1) = mcolSysCode(i).isDirty
        sData(giSysCodeISDeleted, i - 1) = mcolSysCode(i).isDeleted
    Next
       
    getState = True
    Exit Function

getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=3700047902C7
Private Function unPack(sData() As String, iIndex As Integer, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    Dim oSysCode As SysCode
        
    Set mcolSysCode = New Collection
    
    For iIndex = LBound(sData, giTWODIM) To UBound(sData, giTWODIM)
        If moInstanceInfo.objectContext Is Nothing Then
           Set oSysCode = New SysCode
        Else 'MTS present
           Set oSysCode = moInstanceInfo.objectContext.CreateInstance("brsvc.SysCode")
        End If
               
        
        With oSysCode
            
            .sysCodeId = CLng(sData(giSysCodeId, iIndex))
            .name = CStr(sData(giName, iIndex))
            .code = CStr(sData(giCode, iIndex))
            .description = CStr(sData(giDescription, iIndex))
            .isDeleted = False
            .isNew = False
            .isDirty = False
            
            mcolSysCode.Add oSysCode, CStr(sData(giSysCodeId, iIndex))
            
        End With
    Next
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=370004790334
Private Sub Class_Terminate()
    Set theSysCodeDT = Nothing
End Sub
'##ModelId=3712453703A2
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3712453703DE
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3712453703DF
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub


