VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 4  'RequiresNewTransaction
END
Attribute VB_Name = "UCMaintRltnController"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F71FDB0078"
'##ModelId=36F71FDB0122
Private Const msDSN As String = "DSN=remulak;UID=remulak;PWD=remulak;"
'##ModelId=3703E8DE01CC
Private mcolCustomer As New Collection
'##ModelId=3703E8DE01FE
Private mcolAddress As New Collection

Implements ObjectControl
'##ModelId=3712452A0322
Dim moInstanceInfo As InstanceUDT



'##ModelId=36F71FDB0123
Public Function RltnInquiry(ByVal sCustomerNumber As String, sData() As String, sDataLocale() As String, sDataAddress() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo RltnInquiryErr
    
    RltnInquiry = False
    
    'MTS Check
    If moInstanceInfo.objectContext Is Nothing Then
       Set oContextDT = New dtsvc.ContextDT
       Set oCustomer = New Customer
    Else 'MTS present
       Set oContextDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.ContextDT")
       Set oCustomer = moInstanceInfo.objectContext.CreateInstance("brsvc.Customer")
    End If
    
    If oContextDT.DTSetContext(msDSN, False, lErrno, sErrDescr) Then
       If oCustomer.getInfo(sCustomerNumber, True, msDSN, lErrno, sErrDescr) Then
          If oCustomer.getState(sData, sDataLocale, sDataAddress, lErrno, sErrDescr) Then
          
            RltnInquiry = True
            
            Set oCustomer = Nothing
            
          End If
        End If
    End If
    
    'if all went well
    If RltnInquiry Then
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTSetComplete(False, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             RltnInquiry = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetComplete
          Exit Function
       End If
    Else 'troubles ahead
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTsetAbort(False, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             RltnInquiry = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetAbort
          Exit Function
       End If
    End If
        
RltnInquiryErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=370004770276
Public Function SysCodeInquiry(ByVal sName As String, sData() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo SysCodeInquiryErr
          
    SysCodeInquiry = False
    
    'MTS Check
    If moInstanceInfo.objectContext Is Nothing Then
       Set oContextDT = New dtsvc.ContextDT
       Set oSysCode = New SysCode
    Else 'MTS present
       Set oContextDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.ContextDT")
       Set oSysCode = moInstanceInfo.objectContext.CreateInstance("brsvc.SysCode")
    End If
    
    If oContextDT.DTSetContext(msDSN, False, lErrno, sErrDescr) Then
       If oSysCode.getInfo(sName, True, msDSN, lErrno, sErrDescr) Then
          If oSysCode.getState(sData, lErrno, sErrDescr) Then
          
            SysCodeInquiry = True
            
            Set oSysCode = Nothing
            
          End If
        End If
    End If
    
    'if all went well
    If SysCodeInquiry Then
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTSetComplete(False, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             SysCodeInquiry = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetComplete
          Exit Function
       End If
    Else 'troubles ahead
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTsetAbort(False, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             SysCodeInquiry = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetAbort
          Exit Function
       End If
    End If
        
SysCodeInquiryErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8DE0270
Private Function persistCustomerRltn(Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo persistCustomerRltnErr
    
    Dim iIndex As Integer
    
    persistCustomerRltn = False
    
    'persist address
    For iIndex = 1 To mcolAddress.Count
        If mcolAddress(iIndex).saveInfo(msDSN, lErrno, sErrDescr) Then
           persistCustomerRltn = True
        End If
    Next
    
    'persist customer....within customer, locale will be persisted
    For iIndex = 1 To mcolCustomer.Count
        If mcolCustomer(iIndex).saveInfo(msDSN, lErrno, sErrDescr) Then
           persistCustomerRltn = True
        End If
    Next
    
    Exit Function
 
persistCustomerRltnErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8DE02A8
Public Function saveCustomerRltn(sCustomerData() As String, sLocaleData() As String, sAddressData() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo saveCustomerRltnErr
    
    saveCustomerRltn = False
    
    sCustomerNumber = sCustomerData(giCustomerNumber, 0)
    
    'MTS Check
    If moInstanceInfo.objectContext Is Nothing Then
       Set oContextDT = New dtsvc.ContextDT
       Set oCustomer = New Customer
       Set oLocale = New Locale
       Set oAddress = New Address
    Else 'MTS present
       Set oContextDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.ContextDT")
       Set oCustomer = moInstanceInfo.objectContext.CreateInstance("brsvc.Customer")
       Set oLocale = moInstanceInfo.objectContext.CreateInstance("brsvc.Locale")
       Set oAddress = moInstanceInfo.objectContext.CreateInstance("brsvc.Address")
    End If
    
    'Start transaction with bAction set to True for Unit of work
    If oContextDT.DTSetContext(msDSN, True, lErrno, sErrDescr) Then
       If sCustomerData(giCustomerISNew, 0) = True Then 'new customer
          If oCustomer.setState(sCustomerData, lErrno, sErrDescr) Then
             mcolCustomer.Add oCustomer, CStr(oCustomer.customerId)
             If oAddress.setState(sAddressData, lErrno, sErrDescr) Then
                Set mcolAddress = oAddress.mcolAddress
                Set oLocale.theCustomer = oCustomer
                If oLocale.setState(sLocaleData, lErrno, sErrDescr) Then
                   Set oCustomer.theLocale = oLocale.mcolLocale
                   'now our objects are in memory and reflect the work
                   'done in the UI...but not persisted yet. Any unique
                   'business rules would be sent from here
                   If persistCustomerRltn(lErrno, sErrDescr) Then
                      saveCustomerRltn = True
                   End If
                End If
             End If
           End If
        Else 'Customer is not new
           If oCustomer.getInfo(sCustomerNumber, True, lErrno, sErrDescr) Then
              If oCustomer.setState(sCustomerData, lErrno, sErrDescr) Then
                 mcolCustomer.Add oCustomer, CStr(oCustomer.customerId)
                 If oAddress.setState(sAddressData, lErrno, sErrDescr) Then
                    Set mcolAddress = oAddress.mcolAddress
                    If oLocale.setState(sLocaleData, lErrno, sErrDescr) Then
                       Set oCustomer.theLocale = oLocale.mcolLocale
                        'now our objects are in memory and reflect the work
                        'done in the UI...but not persisted yet. Any unique
                        'business rules would be sent from here
                       If persistCustomerRltn(lErrno, sErrDescr) Then
                          saveCustomerRltn = True
                       End If
                     End If
                 End If
              End If
           End If
        End If
    End If
        
    'if all went well
    If saveCustomerRltn Then
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTSetComplete(True, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             saveCustomerRltn = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetComplete
          Exit Function
       End If
    Else 'troubles ahead
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTsetAbort(True, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             saveCustomerRltn = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetAbort
          Exit Function
       End If
    End If
        
saveCustomerRltnErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3712452B0050
Private Sub ObjectControl_Activate()
   Set moInstanceInfo.objectContext = GetObjectContext()
End Sub
'##ModelId=3712452B0051
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3712452B0082
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
