VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "AddressDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08DC00230"
Option Base 0
Option Explicit
Implements ICrud

'##ModelId=36F0ADE200C8
Public theAccess As Access

'##ModelId=36FDCEDA0230
Private Const msAddress As String = "T_Address"
Implements ObjectControl
'##ModelId=3712431E01EC
Dim moInstanceInfo As InstanceUDT


'##ModelId=36F15D770244
Private Function ICrud_getInfo(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
        
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus

    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "maddressID" & gsCOMMASPACE
    sQry = sQry & "maddressLine1" & gsCOMMASPACE
    sQry = sQry & "maddressLine2" & gsCOMMASPACE
    sQry = sQry & "maddressLine3" & gsCOMMASPACE
    sQry = sQry & "mcity" & gsCOMMASPACE
    sQry = sQry & "mstate" & gsCOMMASPACE
    sQry = sQry & "mzip"
    sQry = sQry & gsFROM
    sQry = sQry & msAddress
    sQry = sQry & gsWHERE
    sQry = sQry & "maddressId" & gsEQUALS
    sQry = sQry & CLng(sQualifier)
                
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function



'##ModelId=36F15D770208
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...
    GetStatus
    
    SetStatus
End Function

'##ModelId=36F15D7701D6
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...
    GetStatus
    
    SetStatus
End Function

'##ModelId=36F15D77019A
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    ICrud_insert = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsINSERT & gsINTO
    sQry = sQry & msAddress & gsSPACE
    sQry = sQry & gsOP & "maddressId" & gsCOMMASPACE
    sQry = sQry & "maddressLine1" & gsCOMMASPACE
    sQry = sQry & "maddressLine2" & gsCOMMASPACE
    sQry = sQry & "maddressLine3" & gsCOMMASPACE
    sQry = sQry & "mcity" & gsCOMMASPACE
    sQry = sQry & "mstate" & gsCOMMASPACE
    sQry = sQry & "mzip"
    sQry = sQry & gsCP
    sQry = sQry & gsVALUES & gsOP
    sQry = sQry & sData(giAddressId, 0) & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giAddressLine1, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giAddressLine2, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giAddressLine3, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giCity, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giState, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giZip, 0) & gsSQ
    sQry = sQry & gsCP
            
    'Call the operation on the Access class
    If theAccess.DAQuery(sQry, sConnect, lErrNo, sErrDescr) Then
        ICrud_insert = True
    End If
    
    'ReDim the dimension so the data doesn't get passed back
    ReDim sData(0, 0)
    
    SetStatus

End Function
'If MTS is running, then set theAccess with new access
'##ModelId=3712431E0367
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object
'##ModelId=3712431E03A2
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub
'##ModelId=3712431E03A3
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3712431E03D4
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3712431E03D5
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

