VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "ContextDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F5FD580352"
'##ModelId=36F5FD590016
Public theAccess As Access
Implements ObjectControl
'##ModelId=371243420318
Dim moInstanceInfo As InstanceUDT
'##ModelId=36F5FD590046
Public Function DTSetContext(ByVal sConnect As String, Optional ByVal bAction As Boolean, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo DTSetContextErr
    
    'If MTS is running, just return
    If Not moInstanceInfo.objectContext Is Nothing Then
       DTSetContext = True
       Exit Function
    End If
    
    Set theAccess = New dasvc.Access
    Set goAccess = theAccess
    
    DTSetContext = False
    
    If DTSetConnect(sConnect, lErrNo, sErrDescr) Then
       If bAction Then
          If theAccess.DABeginTrans(lErrNo, sErrDescr) Then
             DTSetContext = True
             Exit Function
          End If
       Else
          DTSetContext = True
          Exit Function
       End If
    End If
       
DTSetContextErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36F5FD59004B
Public Function DTSetConnect(ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo DTSetConnectErr
    
    DTSetConnect = False
    
    If theAccess.DAConnect(sConnect, lErrNo, sErrDescr) Then
        DTSetConnect = True
        Exit Function
    End If
    
DTSetConnectErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36F5FD590084
Public Function DTSetComplete(Optional ByVal bAction As Boolean, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo DTSetCompleteErr
    
    DTSetComplete = False
    
    If bAction Then
       If Not theAccess.DACommitTrans(lErrNo, sErrDescr) Then
            Exit Function
       End If
    End If
    
    'Close the connection
    If DTSetClose(lErrNo, sErrDescr) Then
        DTSetComplete = True
        Exit Function
    End If
    
DTSetCompleteErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36F5FD5900B4
Public Function DTsetAbort(Optional lErrNo As Long, Optional sErrDescr As String) As Boolean

    On Error GoTo DTSetAbortErr

    DTsetAbort = False
    
    If theAccess.DARollBack(lErrNo, sErrDescr) Then
        DTsetAbort = True
        Exit Function
    End If
    
DTSetAbortErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36F5FD5900B7
Private Function DTSetClose(Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo DTSetCloseErr
    
    DTSetClose = False
    
    'Close the connection
    If Not theAccess.DAClose(lErrNo, sErrDescr) Then
        Exit Function
    End If
    
    DTSetClose = True
    Exit Function
    
DTSetCloseErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=371243430048
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=371243430049
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=371243430078
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

