VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "CustomerDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36EC83DB003C"
Implements ICrud
Option Base 0
Option Explicit

'##ModelId=36F0A6FA035C
Public theAccess As Access
'##ModelId=36F71F77021C
Private Const msCustomer As String = "T_Customer"
Implements ObjectControl
'##ModelId=3712431200B6
Dim moInstanceInfo As InstanceUDT


'##ModelId=36F162BD005C
Private Function ICrud_getInfo(ByVal sQualifier As String, sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "mcustomerID" & gsCOMMASPACE
    sQry = sQry & "mcustomerNumber" & gsCOMMASPACE
    sQry = sQry & "mfirstName" & gsCOMMASPACE
    sQry = sQry & "mlastName" & gsCOMMASPACE
    sQry = sQry & "mmiddleInitial" & gsCOMMASPACE
    sQry = sQry & "mprefix" & gsCOMMASPACE
    sQry = sQry & "msuffix" & gsCOMMASPACE
    sQry = sQry & "mphone1" & gsCOMMASPACE
    sQry = sQry & "mphone2" & gsCOMMASPACE
    sQry = sQry & "meMail"
    sQry = sQry & gsFROM
    sQry = sQry & msCustomer
    sQry = sQry & gsWHERE
    sQry = sQry & "mcustomerNumber" & gsEQUALS
    sQry = sQry & gsSQ
    sQry = sQry & sQualifier
    sQry = sQry & gsSQ
    
            
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function
'##ModelId=3726710602C6
Public Function getInfoById(ByVal lCustomerId As Long, sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    getInfoById = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "mcustomerID" & gsCOMMASPACE
    sQry = sQry & "mcustomerNumber" & gsCOMMASPACE
    sQry = sQry & "mfirstName" & gsCOMMASPACE
    sQry = sQry & "mlastName" & gsCOMMASPACE
    sQry = sQry & "mmiddleInitial" & gsCOMMASPACE
    sQry = sQry & "mprefix" & gsCOMMASPACE
    sQry = sQry & "msuffix" & gsCOMMASPACE
    sQry = sQry & "mphone1" & gsCOMMASPACE
    sQry = sQry & "mphone2" & gsCOMMASPACE
    sQry = sQry & "meMail"
    sQry = sQry & gsFROM
    sQry = sQry & msCustomer
    sQry = sQry & gsWHERE
    sQry = sQry & "mcustomerId" & gsEQUALS
    sQry = sQry & lCustomerId
               
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
       getInfoById = True
    End If
    
    SetStatus
    
End Function

'##ModelId=36F162BD0028
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...
    GetStatus

    SetStatus
End Function

'##ModelId=36F162BC03A2
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...
    GetStatus

    SetStatus
End Function

'##ModelId=36F162BC0334
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    Dim sQry As String
    
    ICrud_insert = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsINSERT & gsINTO
    sQry = sQry & msCustomer & gsSPACE
    sQry = sQry & gsOP & "mcustomerId" & gsCOMMASPACE
    sQry = sQry & "mcustomerNumber" & gsCOMMASPACE
    sQry = sQry & "mfirstName" & gsCOMMASPACE
    sQry = sQry & "mlastName" & gsCOMMASPACE
    sQry = sQry & "mmiddleInitial" & gsCOMMASPACE
    sQry = sQry & "mprefix" & gsCOMMASPACE
    sQry = sQry & "msuffix" & gsCOMMASPACE
    sQry = sQry & "mphone1" & gsCOMMASPACE
    sQry = sQry & "mphone2" & gsCOMMASPACE
    sQry = sQry & "meMail"
    sQry = sQry & gsCP
    sQry = sQry & gsVALUES & gsOP
    sQry = sQry & sData(giCustomerId, 0) & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giCustomerNumber, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giFirstName, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giLastName, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giMiddleInitial, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giPrefix, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giSuffix, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giPhone1, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giPhone2, 0) & gsSQ & gsCOMMASPACE
    sQry = sQry & gsSQ & sData(giEMail, 0) & gsSQ
    sQry = sQry & gsCP
            
    'Call the operation on the Access class
    If theAccess.DAQuery(sQry, sConnect, lErrNo, sErrDescr) Then
        ICrud_insert = True
    End If
    
    'ReDim the dimension so the data doesn't get passed back
    ReDim sData(0, 0)
    
    SetStatus

End Function
'If MTS is running, then set theAccess with new access
'##ModelId=37124312023A
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object
'##ModelId=37124312023B
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub
'##ModelId=37124312026C
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=37124312026D
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3712431202A8
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
