VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "GuitarDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08DF2021C"
Option Base 0
Option Explicit
Implements ICrud

'##ModelId=36F0B05F0370
Public theAccess As Access
'##ModelId=3726712402EE
Private Const msGuitar As String = "Guitar_V"
Implements ObjectControl

'##ModelId=37267124032C
Dim moInstanceInfo As InstanceUDT

'##ModelId=36F15D7C015F
Private Function ICrud_getInfo(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
        
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "mstringCount" & gsCOMMASPACE
    sQry = sQry & "mright" & gsCOMMASPACE
    sQry = sQry & "mfretLess" & gsCOMMASPACE
    sQry = sQry & "mmake" & gsCOMMASPACE
    sQry = sQry & "mmodel" & gsCOMMASPACE
    sQry = sQry & "mage" & gsCOMMASPACE
    sQry = sQry & "mguitarId" & gsCOMMASPACE
    sQry = sQry & "mproductId" & gsCOMMASPACE
    sQry = sQry & "mdescription" & gsCOMMASPACE
    sQry = sQry & "mprice" & gsCOMMASPACE
    sQry = sQry & "mdiscount" & gsCOMMASPACE
    sQry = sQry & "mquantityOnHand" & gsCOMMASPACE
    sQry = sQry & "meoq" & gsCOMMASPACE
    sQry = sQry & "mproductType"
    sQry = sQry & gsFROM
    sQry = sQry & msGuitar
    sQry = sQry & gsWHERE
    sQry = sQry & "mproductId" & gsEQUALS
    sQry = sQry & CLng(sQualifier)
                
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function

'##ModelId=36F15D7C012E
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D7C012C
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D7C00F0
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function
'If MTS is running, then set theAccess with new access
'##ModelId=3726712500F0
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object

'##ModelId=3726712500F1
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub

'##ModelId=37267125012C
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=37267125012D
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=37267125015E
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub


