VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "OrderDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08DB70226"
Option Base 0
Option Explicit
Implements ICrud

'##ModelId=36F0ADD90320
Public theAccess As Access
'##ModelId=3726710B00D2
Private Const msOrder As String = "T_Order"
Implements ObjectControl

'##ModelId=3726710B00D5
Dim moInstanceInfo As InstanceUDT

'##ModelId=36F15D7601E0
Private Function ICrud_getInfo(ByVal sQualifier As String, sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus
    
        
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "morderID" & gsCOMMASPACE
    sQry = sQry & "morderNumber" & gsCOMMASPACE
    sQry = sQry & "minvoiceId" & gsCOMMASPACE
    sQry = sQry & "mcustomerId"
    sQry = sQry & gsFROM
    sQry = sQry & msOrder
    sQry = sQry & gsWHERE
    sQry = sQry & "morderNumber" & gsEQUALS
    sQry = sQry & gsSQ
    sQry = sQry & sQualifier
    sQry = sQry & gsSQ
    
            
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function

'##ModelId=36F15D7601A5
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D760173
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D760172
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function
'If MTS is running, then set theAccess with new access
'##ModelId=3726710B02F8
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object
'##ModelId=3726710B02F9
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub

'##ModelId=3726710B032A
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=3726710B0366
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3726710B0367
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

