VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "SheetMusicDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08E0200BE"
Option Base 0
Option Explicit
Implements ICrud

'##ModelId=36F0B03803AC
Public theAccess As Access
'##ModelId=3726712A0082
Private Const msSheetMusic As String = "SheetMusic_V"
Implements ObjectControl

'##ModelId=3726712A00C0
Dim moInstanceInfo As InstanceUDT

'##ModelId=36F15D7D0154
Private Function ICrud_getInfo(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
        
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "mpages" & gsCOMMASPACE
    sQry = sQry & "msheetId" & gsCOMMASPACE
    sQry = sQry & "mproductId" & gsCOMMASPACE
    sQry = sQry & "mdescription" & gsCOMMASPACE
    sQry = sQry & "mprice" & gsCOMMASPACE
    sQry = sQry & "mdiscount" & gsCOMMASPACE
    sQry = sQry & "mquantityOnHand" & gsCOMMASPACE
    sQry = sQry & "meoq" & gsCOMMASPACE
    sQry = sQry & "mproductType"
    sQry = sQry & gsFROM
    sQry = sQry & msSheetMusic
    sQry = sQry & gsWHERE
    sQry = sQry & "mproductId" & gsEQUALS
    sQry = sQry & CLng(sQualifier)
                
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function

'##ModelId=36F15D7D0122
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D7D00E7
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D7D00E6
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function
'If MTS is running, then set theAccess with new access
'##ModelId=3726712A023A
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object

'##ModelId=3726712A023B
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub

'##ModelId=3726712A0276
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=3726712A02A8
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=3726712A02A9
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
