VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UIMaintRltnController"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36EC82970366"
Option Base 0
Option Explicit

'##ModelId=36F720A100C0
Public moUCMaintRltnController As brsvc.UCMaintRltnController
'##ModelId=372671700070
Public moUtility As New Utility
'##ModelId=36FDCF0C00A0
Public mcolCustomer As New Collection
'##ModelId=36FDCF0C00DC
Public mcolLocale As New Collection
'##ModelId=36FDCF0C00DD
Public mcolAddress As New Collection
'##ModelId=370003CB02F8
Public mcolRole As New Collection
'##ModelId=3703E85101CC
Private msCustomerData() As String
'##ModelId=3703E85101CD
Private msLocaleData() As String
'##ModelId=3703E8510208
Private msAddressData() As String
'getInfo in every form controller sets up all the data associated
'with the most common access to the screen
'##ModelId=36F1FEA7029E
Public Function getInfo(ByVal sCustomerNumber As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoErr
    
    Dim customerInfo As CustomerUDT
    Dim localeInfo As LocaleUDT
    Dim AddressInfo As AddressUDT
    
    Dim sDataLocale() As String
    Dim sDataAddress() As String
    Dim sData() As String
    
    Dim iIndex As Integer
        
    getInfo = False
    
    Set moUCMaintRltnController = New brsvc.UCMaintRltnController
        
    If moUCMaintRltnController.RltnInquiry(sCustomerNumber, sData, sDataLocale, sDataAddress, lErrNo, sErrDescr) Then
       moUtility.freeCollection mcolCustomer
       For iIndex = LBound(sData, giTWODIM) To UBound(sData, giTWODIM)
        
           With customerInfo
                .customerId = CLng(sData(giCustomerId, iIndex))
                .customerNumber = CStr(sData(giCustomerNumber, iIndex))
                .firstName = CStr(sData(giFirstName, iIndex))
                .lastName = CStr(sData(giLastName, iIndex))
                .middleInitial = CStr(sData(giMiddleInitial, iIndex))
                .prefix = CStr(sData(giPrefix, iIndex))
                .suffix = CStr(sData(giSuffix, iIndex))
                .phone1 = CStr(sData(giPhone1, iIndex))
                .phone2 = CStr(sData(giPhone2, iIndex))
                .eMail = CStr(sData(giEMail, iIndex))
                .isDeleted = False
                .isNew = False
                .isDirty = False
           End With
            
           mcolCustomer.Add customerInfo, CStr(customerInfo.customerId)
        Next
        
        moUtility.freeCollection mcolLocale
        
        If sDataLocale(0, 0) = "" Then
        Else
        
            For iIndex = LBound(sDataLocale, giTWODIM) To UBound(sDataLocale, giTWODIM)
            
                With localeInfo
                    .localeId = CLng(sDataLocale(giLocaleId, iIndex))
                    .addressId = CLng(sDataLocale(giLocaleAddressId, iIndex))
                    .customerId = CLng(sDataLocale(giLocaleCustomerId, iIndex))
                    .role = CInt(sDataLocale(giRole, iIndex))
                    .isDirty = False
                    .isDeleted = False
                    .isNew = False
                End With
                
                mcolLocale.Add localeInfo, CStr(localeInfo.localeId)
            Next
        End If
        
        moUtility.freeCollection mcolAddress
        
        If sDataAddress(0, 0) = "" Then
        Else
            For iIndex = LBound(sDataAddress, giTWODIM) To UBound(sDataAddress, giTWODIM)
            
                With AddressInfo
                    .addressId = CLng(sDataAddress(giAddressId, iIndex))
                    .addressLine1 = CStr(sDataAddress(giAddressLine1, iIndex))
                    .addressLine2 = CStr(sDataAddress(giAddressLine2, iIndex))
                    .addressLine3 = CStr(sDataAddress(giAddressLine3, iIndex))
                    .city = CStr(sDataAddress(giCity, iIndex))
                    .state = CStr(sDataAddress(giState, iIndex))
                    .zip = CStr(sDataAddress(giZip, iIndex))
                    .isDirty = False
                    .isDeleted = False
                    .isNew = False
                End With
                
                mcolAddress.Add AddressInfo, CStr(AddressInfo.addressId)
            Next
        End If
        
        getInfo = True
       
        Set moUCMaintRltnController = Nothing
        
        ReDim sData(0, 0)
        ReDim sDataAddress(0, 0)
        ReDim sDataLocale(0, 0)
               
        Exit Function
    End If
        
getInfoErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=370003CB03D4
Public Function getSysCode(ByVal sName As String, sData() As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean

    On Error GoTo getSysCodeErr
    
    Dim SysCodeInfo As SysCodeUDT
    
    Dim iIndex As Integer
        
    getSysCode = False
    
    Set moUCMaintRltnController = New brsvc.UCMaintRltnController
        
    If moUCMaintRltnController.SysCodeInquiry(sName, sData, lErrNo, sErrDescr) Then
    
        For iIndex = LBound(sData, giTWODIM) To UBound(sData, giTWODIM)
            
            With SysCodeInfo
                 .sysCodeId = CLng(sData(giSysCodeId, iIndex))
                 .name = CStr(sData(giName, iIndex))
                 .code = CStr(sData(giCode, iIndex))
                 .description = CStr(sData(giDescription, iIndex))
                 .isDeleted = False
                 .isNew = False
                 .isDirty = False
            End With
             
            mcolRole.Add SysCodeInfo, CStr(SysCodeInfo.code)
        Next
        
        getSysCode = True
       
        Set moUCMaintRltnController = Nothing
       
        Exit Function
    End If
        
getSysCodeErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'This operation will save all information related to a customer
'including address and locale (role) changes. All of this information is
'communicated at one time across the wire to the business layer
'##ModelId=3703E8510317
Public Function saveCustomerRltn(Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    On Error GoTo saveCustomerRltnErr
    
       
    Dim customerInfo As CustomerUDT
    Dim localeInfo As LocaleUDT
    Dim AddressInfo As AddressUDT
    Dim iIndex As Integer
    
    saveCustomerRltn = False
    
    'Set dynamic string arrays in preparation for trip out
    ReDim msCustomerData(giCustomerCount - 1, 0)
    ReDim msLocaleData(giLocaleCount - 1, 0)
    ReDim msAddressData(giAddressCount - 1, 0)
        
    'assign it to UDT
    customerInfo = mcolCustomer(giONEDIM) 'only one customer
    loadCustomerData msCustomerData, customerInfo, giONEDIM
    
    For iIndex = 1 To mcolLocale.Count
        'assign it to UDT
        localeInfo = mcolLocale(iIndex)
        If localeInfo.isDeleted = True Or localeInfo.isDirty = True Or localeInfo.isNew = True Then
        
           loadLocaleData msLocaleData, localeInfo, iIndex
        End If
    Next
    
    For iIndex = 1 To mcolAddress.Count
        'assign it to UDT
        AddressInfo = mcolAddress(iIndex)
        If AddressInfo.isDeleted = True Or AddressInfo.isDirty = True Or AddressInfo.isNew = True Then
        
           loadAddressData msAddressData, AddressInfo, iIndex
        End If
    Next
    
    Set moUCMaintRltnController = New brsvc.UCMaintRltnController
     
    If moUCMaintRltnController.saveCustomerRltn(msCustomerData, msLocaleData, msAddressData, lErrNo, sErrDescr) Then
       saveCustomerRltn = True
    End If
    
    Exit Function
    
         
saveCustomerRltnErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8510353
Private Sub loadCustomerData(msCustomerData() As String, udtTemp As Variant, iIndex As Integer)

    ReDim Preserve msCustomerData(giCustomerCount - 1, iIndex - 1)
    
    msCustomerData(giCustomerId, iIndex - 1) = udtTemp.customerId
    msCustomerData(giCustomerNumber, iIndex - 1) = udtTemp.customerNumber
    msCustomerData(giFirstName, iIndex - 1) = udtTemp.firstName
    msCustomerData(giLastName, iIndex - 1) = udtTemp.lastName
    msCustomerData(giMiddleInitial, iIndex - 1) = udtTemp.middleInitial
    msCustomerData(giPrefix, iIndex - 1) = udtTemp.prefix
    msCustomerData(giSuffix, iIndex - 1) = udtTemp.suffix
    msCustomerData(giPhone1, iIndex - 1) = udtTemp.phone1
    msCustomerData(giPhone2, iIndex - 1) = udtTemp.phone2
    msCustomerData(giEMail, iIndex - 1) = udtTemp.eMail
    msCustomerData(giCustomerISNew, iIndex - 1) = udtTemp.isNew
    msCustomerData(giCustomerISDirty, iIndex - 1) = udtTemp.isDirty
    msCustomerData(giCustomerISDeleted, iIndex - 1) = udtTemp.isDeleted

End Sub
'##ModelId=3703E8510386
Private Sub loadLocaleData(msLocaleData() As String, udtTemp As Variant, iIndex As Integer)

    ReDim Preserve msLocaleData(giLocaleCount - 1, iIndex - 1)
    
    msLocaleData(giLocaleId, iIndex - 1) = udtTemp.localeId
    msLocaleData(giLocaleCustomerId, iIndex - 1) = udtTemp.customerId
    msLocaleData(giLocaleAddressId, iIndex - 1) = udtTemp.addressId
    msLocaleData(giRole, iIndex - 1) = udtTemp.role
    msLocaleData(giLocaleISNew, iIndex - 1) = udtTemp.isNew
    msLocaleData(giLocaleISDirty, iIndex - 1) = udtTemp.isDirty
    msLocaleData(giLocaleISDeleted, iIndex - 1) = udtTemp.isDeleted

End Sub
'##ModelId=3703E852000A
Private Sub loadAddressData(msAddressData() As String, udtTemp As Variant, iIndex As Integer)

    ReDim Preserve msAddressData(giAddressCount - 1, iIndex - 1)
    
    msAddressData(giAddressId, iIndex - 1) = udtTemp.addressId
    msAddressData(giAddressLine1, iIndex - 1) = udtTemp.addressLine1
    msAddressData(giAddressLine2, iIndex - 1) = udtTemp.addressLine2
    msAddressData(giAddressLine3, iIndex - 1) = udtTemp.addressLine3
    msAddressData(giCity, iIndex - 1) = udtTemp.city
    msAddressData(giState, iIndex - 1) = udtTemp.state
    msAddressData(giZip, iIndex - 1) = udtTemp.zip
    msAddressData(giAddressISNew, iIndex - 1) = udtTemp.isNew
    msAddressData(giAddressISDirty, iIndex - 1) = udtTemp.isDirty
    msAddressData(giAddressISDeleted, iIndex - 1) = udtTemp.isDeleted

End Sub
