VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Locale"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D33890140"
Option Base 0
Option Explicit

'##ModelId=36D23A520190
Private mrole As Integer

'##ModelId=36D240B103C0
Private mlocaleId As Long

'##ModelId=36FDCE7A0370
Public mcolLocale As Collection

'##ModelId=36FBFF15028A
Public theCustomer As Customer

'##ModelId=36FBFF12012C
Public theAddress As Address

'##ModelId=36FDCE7A03DE
Private misDirty As Boolean


'##ModelId=36FDCE7A03DF
Private misNew As Boolean

'##ModelId=36FDCE7B0032
Private misDeleted As Boolean

'##ModelId=36FDCE7B0066
Private theLocaleDT As dtsvc.LocaleDT
Implements ObjectControl
'##ModelId=371244EB0106
Dim moInstanceInfo As InstanceUDT


'##ModelId=36EAD735033E
Public Property Let role(ByVal Value As Integer)
    mrole = Value
End Property

'##ModelId=36EAD7360032
Public Property Get role() As Integer
    role = mrole
End Property

'##ModelId=36EAD73600A0
Public Property Let localeId(ByVal Value As Long)
    mlocaleId = Value
End Property
'##ModelId=36EAD73601AE
Public Property Get localeId() As Long
    localeId = mlocaleId
End Property

'##ModelId=36FDCE7B0140
Public Property Get isDirty() As Boolean
    isDirty = misDirty
End Property


'##ModelId=36FDCE7B010E
Public Property Let isDirty(ByVal Value As Boolean)
    misDirty = Value
End Property
'##ModelId=36FDCE7B017E
Public Property Get isNew() As Boolean
    isNew = misNew
End Property


'##ModelId=36FDCE7B017C
Public Property Let isNew(ByVal Value As Boolean)
    misNew = Value
End Property
'##ModelId=36FDCE7B01EA
Public Property Get isDeleted() As Boolean
    isDeleted = misDeleted
End Property


'##ModelId=36FDCE7B01AE
Public Property Let isDeleted(ByVal Value As Boolean)
    misDeleted = Value
End Property


'##ModelId=36FDCE7B021C
Public Property Get colLocale() As Collection
    Set colLocale = mcolLocale
End Property
'##ModelId=36FDCE7B01EB
Public Property Set colLocale(colValue As Collection)
    Set mcolLocale = colValue
End Property
'##ModelId=3703E8D1006E
Private Sub getLocaleBase(sData() As String)

    ReDim sData(giLocaleCount - 1, 0)

    sData(giLocaleId, 0) = localeId
    sData(giLocaleCustomerId, 0) = theCustomer.customerId
    sData(giLocaleAddressId, 0) = theAddress.addressId
    sData(giRole, 0) = role
    sData(giLocaleISNew, 0) = isNew
    sData(giLocaleISDirty, 0) = isDirty
    sData(giLocaleISDeleted, 0) = isDeleted
End Sub
'##ModelId=36FDCE7B0258
Public Function getInfoByCustomerId(Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean

    On Error GoTo getInfoErr
    
    Dim sData() As String
    Dim lCustomerId As Long
    Dim oICrud As ICrud
    Dim oLocale As Locale
    Dim iIndex As Integer
    
    getInfoByCustomerId = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theLocaleDT = New dtsvc.LocaleDT
    Else
        Set theLocaleDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.LocaleDT")
    End If
    
    'Talk To The Interface
    Set oICrud = theLocaleDT
        
    lCustomerId = theCustomer.customerId
    
    If oICrud.getInfo(CStr(lCustomerId), sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, True, sConnect, lErrno, sErrDescr) Then
           getInfoByCustomerId = True
       End If
    End If
    
    Exit Function

   
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36FDCE7B028A
Public Function getState(sGetLocale() As String, SGetAddress() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
    Dim i As Integer
            
    ReDim sGetLocale(6, 0)
    
    sGetLocale(giLocaleId, 0) = localeId
    sGetLocale(giLocaleCustomerId, 0) = theCustomer.customerId
    sGetLocale(giLocaleAddressId, 0) = theAddress.addressId
    sGetLocale(giRole, 0) = role
    sGetLocale(giLocaleISNew, 0) = isNew
    sGetLocale(giLocaleISDirty, 0) = isDirty
    sGetLocale(giLocaleISDeleted, 0) = isDeleted
    
    If theAddress.getState(SGetAddress, lErrno, sErrDescr) Then
        getState = True
        Exit Function
    End If
    
getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8D10110
Public Function saveInfo(Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo saveInfoErr
    
    Dim oICrud As ICrud
    Dim sLocaleData() As String
       
    saveInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theLocaleDT = New dtsvc.LocaleDT
    Else
        Set theLocaleDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.LocaleDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theLocaleDT
    
    'get customer information into an array to send onward
    getLocaleBase sLocaleData
    
    'Depending on internal state, the correct message is invoked
    If isNew Then
       If oICrud.Insert("", sLocaleData, sConnect, lErrno, sErrDescr) Then
          saveInfo = True
          Exit Function
       End If
    Else
       If isDirty Then
          If oICrud.Update("", sLocaleData, sConnect, lErrno, sErrDescr) Then
             saveInfo = True
             Exit Function
          End If
       Else
          If isDeleted Then
             If oICrud.Delete("", sLocaleData, sConnect, lErrno, sErrDescr) Then
                saveInfo = True
                Exit Function
             End If
          End If
       End If
    End If
    
    Exit Function
    
saveInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3703E8D1014C
Public Function setState(sLocaleData() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo setStateErr
        
    setState = False
    Dim i As Integer
    
    'No locale records, get out
    If sLocaleData(giZERODIM, giZERODIM) = "" Then
        setState = True
        Exit Function
    End If
    
    If unPack(sLocaleData, giZERODIM, False) Then
       setState = True
    End If
    
    Exit Function

setStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=36FDCE7B02C6
Private Function unPack(sData() As String, Optional ByVal bInquiry As Boolean, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
            
    On Error GoTo unPackErr
    
    Dim iIndex As Integer
    Dim oLocale As Locale
    Dim bOk As Boolean
    
    Set mcolLocale = New Collection
    
    unPack = False
    bOk = False
    
    
    
    For iIndex = LBound(sData, giTWODIM) To UBound(sData, giTWODIM)
        Set oLocale = New Locale
        Set oLocale.theCustomer = theCustomer
        If moInstanceInfo.objectContext Is Nothing Then
           Set oLocale.theAddress = New Address
        Else
           Set oLocale.theAddress = moInstanceInfo.objectContext.CreateInstance("brsvc.Address")
        End If
         
        With oLocale
            .role = CInt(sData(giRole, iIndex))
            .localeId = CLng(sData(giLocaleId, iIndex))
            .theAddress.addressId = CLng(sData(giLocaleAddressId, iIndex))
            If bInquiry Then
                .isDirty = False
                .isDeleted = False
                .isNew = False
            Else
                .isDirty = CBool(sData(giLocaleISDirty, iIndex))
                .isDeleted = CBool(sData(giLocaleISDeleted, iIndex))
                .isNew = CBool(sData(giLocaleISNew, iIndex))
            End If
            
        End With
        
        If bInquiry Then
           If Not oLocale.theAddress.getInfo(oLocale.theAddress.addressId, sConnect, lErrno, sErrDescr) Then
              Exit Function
           Else
              bOk = True
           End If
        Else ' this is an update, delete, insert
           bOk = True
        End If
        
        If bOk Then
           mcolLocale.Add oLocale, CStr(sData(giLocaleId, iIndex))
           unPack = True
        End If
    Next
    
    Exit Function
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=371244EC00BF
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=371244EC00F0
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=371244EC00F1
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

