VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Order"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D32E4017C"
Option Base 0
Option Explicit

'##ModelId=36CB06C10398
Private morderId As Long

'##ModelId=372670620136
Private morderNumber As String

'##ModelId=3712B86A02B2
Private misNew As Boolean

'##ModelId=3712B880014A
Private misDirty As Boolean

'##ModelId=3712B8970348
Private misDeleted As Boolean

'##ModelId=368D34560212
Public theInvoice As Invoice

'##ModelId=36CB1D4600BF
Public theCustomer As Customer

'##ModelId=368D33410173
Public theOrderHeader As OrderHeader

'##ModelId=368D334E03AD
Public theOrderSummary As OrderSummary

'##ModelId=368D33490119
Public theOrderLine As New Collection

'##ModelId=372670620250
Private theOrderDT As dtsvc.OrderDT
Implements ObjectControl

'##ModelId=372670620282
Dim moInstanceInfo As InstanceUDT


'##ModelId=3726706202BC
Public Property Get orderNumber() As String
   Let orderNumber = morderNumber
End Property


'##ModelId=372670620283
Public Property Let orderNumber(ByVal Value As String)
    Let morderNumber = Value
End Property
'##ModelId=3712CEB902E4
Public Property Get isDeleted() As Boolean
   Let isDeleted = misDeleted
End Property

'##ModelId=3712CEB90208
Public Property Let isDeleted(ByVal Value As Boolean)
    Let misDeleted = Value
End Property

'##ModelId=3712CEB9019A
Public Property Get isDirty() As Boolean
   Let isDirty = misDirty
End Property

'##ModelId=3712CEB900F0
Public Property Let isDirty(ByVal Value As Boolean)
    Let misDirty = Value
End Property

'##ModelId=3712CEB90082
Public Property Get isNew() As Boolean
   Let isNew = misNew
End Property

'##ModelId=3712CEB8038E
Public Property Let isNew(ByVal Value As Boolean)
    Let misNew = Value
End Property

'##ModelId=3712CEB80320
Public Property Get orderId() As Long
   Let orderId = morderId
End Property

'##ModelId=3712CEB80244
Public Property Let orderId(ByVal Value As Long)
    Let morderId = Value
End Property
'##ModelId=37267063001E
Public Function getInfo(ByVal sOrderNumber As String, Optional bExpand As Boolean, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoErr
    
    Dim sData() As String
    
    Dim oICrud As ICrud
    Dim oOrder As Order
    Dim oOrderLine As OrderLine
    Dim oOrderSummary As OrderSummary
    Dim oOrderHeader As OrderHeader
    Dim oCustomer As Customer
    
    getInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theOrderDT = New dtsvc.OrderDT
    Else
        Set theOrderDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.OrderDT")
    End If
    
        
    'Talk to the DT interface
    Set oICrud = theOrderDT
    
    If oICrud.getInfo(sOrderNumber, sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          getInfo = True
          If bExpand Then
             If moInstanceInfo.objectContext Is Nothing Then
                Set oOrderHeader = New OrderHeader
                Set oOrderLine = New OrderLine
                Set oOrderSummary = New OrderSummary
             Else
                Set oOrderHeader = moInstanceInfo.objectContext.CreateInstance("brsvc.OrderHeader")
                Set oOrderLine = moInstanceInfo.objectContext.CreateInstance("brsvc.OrderLine")
                Set oOrderSummary = moInstanceInfo.objectContext.CreateInstance("brsvc.OrderSummary")
             End If
            
             If theCustomer.getInfoById(theCustomer.customerId, False, sConnect, lErrno, sErrDescr) Then
                If oOrderHeader.getInfoByOrderId(orderId, sConnect, lErrno, sErrDescr) Then
                   Set theOrderHeader = oOrderHeader
                   Set theOrderHeader.theOrder = Me
                   If oOrderSummary.getInfoByOrderId(orderId, sConnect, lErrno, sErrDescr) Then
                      Set theOrderSummary = oOrderSummary
                      Set theOrderSummary.theOrder = Me
                      Set oOrderLine.theOrder = Me
                      If oOrderLine.getInfoByOrderId(orderId, sConnect, lErrno, sErrDescr) Then
                         Set theOrderLine = oOrderLine.mcolOrderLine
                      End If
                   End If
                End If
             End If
          End If
       End If
    End If
    
    Exit Function
      
        
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
    
End Function
'##ModelId=372670630050
Private Sub getOrderBase(sData() As String)

    ReDim sData(giOrderCount - 1, 0)
    
    sData(giOrderId, 0) = orderId
    sData(giOrderNumber, 0) = orderNumber
    
    'There may not be an invoice for this order yet
    If theInvoice Is Nothing Then
       sData(giInvoiceId, 0) = 0
    Else
       sData(giInvoiceId, 0) = theInvoice.invoiceId
    End If
    
    sData(giOrderCustomerId, 0) = theCustomer.customerId
    sData(giOrderISNew, 0) = isNew
    sData(giOrderISDirty, 0) = isDirty
    sData(giOrderISDeleted, 0) = isDeleted
End Sub
'##ModelId=37267063008C
Public Function getState(sDataOrder() As String, sDataOrderHeader() As String, sDataOrderLine() As String, sDataProduct() As String, sDataOrderSummary() As String, sDataCustomer() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
    
    Dim i As Integer
    Dim sGetOrder() As String
    Dim sGetOrderHeader() As String
    Dim sGetOrderLine() As String
    Dim sGetOrderSummary() As String
    Dim sGetCustomer() As String
    Dim sGetLocale() As String
    Dim SGetAddress() As String
    Dim sGetProduct() As String
        
    ReDim sGetOrder(giOrderCount - 1, 0)
    ReDim sGetOrderHeader(giOrderHeaderCount - 1, 0)
    ReDim sGetOrderLine(giOrderLineCount - 1, 0)
    ReDim sGetOrderSummary(giOrderSummaryCount - 1, 0)
    ReDim sGetCustomer(giCustomerCount - 1, 0)
    ReDim sGetLocale(giLocaleCount - 1, 0)
    ReDim SGetAddress(giAddressCount - 1, 0)
    ReDim sGetProduct(giProductCount - 1, 0)
                
    'get just the order base information
    getOrderBase sDataOrder
    
    'get order header information
    If theOrderHeader.getState(sGetOrderHeader, lErrno, sErrDescr) Then
       sDataOrderHeader = sGetOrderHeader
    Else
       Exit Function
    End If
    
    'get order summary information
    If theOrderSummary.getState(sGetOrderSummary, lErrno, sErrDescr) Then
       sDataOrderSummary = sGetOrderSummary
    Else
       Exit Function
    End If
    
    'get customer information
    If theCustomer.getState(sGetCustomer, sGetLocale, SGetAddress, lErrno, sErrDescr) Then
        sDataCustomer = sGetCustomer
    Else
       Exit Function
    End If
        
    For i = 1 To theOrderLine.Count
        If theOrderLine(i).getState(sGetOrderLine, sGetProduct, lErrno, sErrDescr) Then
           ReDim Preserve sDataOrderLine(giOrderLineCount - 1, i - 1)
           ReDim Preserve sDataProduct(giProductCount - 1, i - 1)
           
           sDataOrderLine(giOrderLineId, i - 1) = sGetOrderLine(giOrderLineId, 0)
           sDataOrderLine(giOrderLineOrderId, i - 1) = sGetOrderLine(giOrderLineOrderId, 0)
           sDataOrderLine(giOrderLineProductId, i - 1) = sGetOrderLine(giOrderLineProductId, 0)
           sDataOrderLine(giQuantity, i - 1) = sGetOrderLine(giQuantity, 0)
           sDataOrderLine(giOrderLineDiscount, i - 1) = sGetOrderLine(giOrderLineDiscount, 0)
           sDataOrderLine(giUnitPrice, i - 1) = sGetOrderLine(giUnitPrice, 0)
           sDataOrderLine(giOrderLineISDeleted, i - 1) = sGetOrderLine(giOrderLineISDeleted, 0)
           sDataOrderLine(giOrderLineISNew, i - 1) = sGetOrderLine(giOrderLineISNew, 0)
           sDataOrderLine(giOrderLineISDirty, i - 1) = sGetOrderLine(giOrderLineISDirty, 0)
           
           'also set the related product information for the orderline
           sDataProduct(giProductId, i - 1) = sGetProduct(giProductId, 0)
           sDataProduct(giProductDescription, i - 1) = sGetProduct(giProductDescription, 0)
           sDataProduct(giPrice, i - 1) = sGetProduct(giPrice, 0)
           sDataProduct(giProductDiscount, i - 1) = sGetProduct(giProductDiscount, 0)
           sDataProduct(giQuantityOnHand, i - 1) = sGetProduct(giQuantityOnHand, 0)
           sDataProduct(giEoq, i - 1) = sGetProduct(giEoq, 0)
           sDataProduct(giProductType, i - 1) = sGetProduct(giProductType, 0)
           sDataProduct(giProductISDeleted, i - 1) = sGetProduct(giProductISDeleted, 0)
           sDataProduct(giProductISNew, i - 1) = sGetProduct(giProductISNew, 0)
           sDataProduct(giProductISDirty, i - 1) = sGetProduct(giProductISDirty, 0)
           
           
         End If
    Next
    
    
    getState = True
    Exit Function

getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726706300FB
Private Function unPack(sData() As String, iIndex As Integer, Optional bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    orderId = CLng(sData(giOrderId, iIndex))
    orderNumber = CStr(sData(giOrderNumber, iIndex))
    
    If moInstanceInfo.objectContext Is Nothing Then
       Set theCustomer = New Customer
    Else
       Set theCustomer = moInstanceInfo.objectContext.CreateInstance("brsvc.Customer")
    End If
    
    theCustomer.customerId = CLng(sData(giOrderCustomerId, iIndex))

    'If the unpack is the result of an inquiry then default
    'the state flags to false, else...use what was passed in
    'from the client
    If bInquiry Then
       isDeleted = False
       isNew = False
       isDirty = False
    Else
       isDeleted = sData(giOrderISDeleted, iIndex)
       isNew = sData(giOrderISNew, iIndex)
       isDirty = sData(giOrderISDirty, iIndex)
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=372670630168
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=372670630169
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=37267063019A
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
