VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "OrderLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D3327003C"
Option Base 0
Option Explicit

'##ModelId=36E0C80C0118
Private mquantity As Integer

'##ModelId=36E0C8230014
Private mdiscount As Currency

'##ModelId=36E0C84C028A
Private mextendedUnitPrice As Currency

'##ModelId=37125F5A0316
Private morderLineId As Long

'##ModelId=3712B8D00352
Private misNew As Boolean

'##ModelId=3712B8D0038E
Private misDirty As Boolean

'##ModelId=3712B8D003C0
Private misDeleted As Boolean

'##ModelId=368D3417005A
Public theShipment As Collection

'##ModelId=368D33C00353
Public theProduct As Product

'##ModelId=368D33490118
Public theOrder As Order
'##ModelId=372670670172
Public mcolOrderLine As New Collection
'##ModelId=3726706701A6
Private theOrderLineDT As dtsvc.OrderLineDT
Implements ObjectControl

'##ModelId=3726706701A9
Dim moInstanceInfo As InstanceUDT

'##ModelId=3712CEBD0352
Public Property Get isDeleted() As Boolean
   Let isDeleted = misDeleted
End Property

'##ModelId=3712CEBD0276
Public Property Let isDeleted(ByVal Value As Boolean)
    Let misDeleted = Value
End Property

'##ModelId=3712CEBD0208
Public Property Get isDirty() As Boolean
   Let isDirty = misDirty
End Property

'##ModelId=3712CEBD0136
Public Property Let isDirty(ByVal Value As Boolean)
    Let misDirty = Value
End Property

'##ModelId=3712CEBD00C8
Public Property Get isNew() As Boolean
   Let isNew = misNew
End Property

'##ModelId=3712CEBD001E
Public Property Let isNew(ByVal Value As Boolean)
    Let misNew = Value
End Property

'##ModelId=3712CEBC0398
Public Property Get orderLineId() As Long
   Let orderLineId = morderLineId
End Property

'##ModelId=3712CEBC02BC
Public Property Let orderLineId(ByVal Value As Long)
    Let morderLineId = Value
End Property

'##ModelId=3712CEBC024E
Public Property Get extendedUnitPrice() As Currency
   Let extendedUnitPrice = mextendedUnitPrice
End Property

'##ModelId=3712CEBC0172
Public Property Let extendedUnitPrice(ByVal Value As Currency)
    Let mextendedUnitPrice = Value
End Property

'##ModelId=3712CEBC0140
Public Property Get discount() As Currency
   Let discount = mdiscount
End Property

'##ModelId=3712CEBC0064
Public Property Let discount(ByVal Value As Currency)
    Let mdiscount = Value
End Property

'##ModelId=3712CEBB03DE
Public Property Get quantity() As Integer
   Let quantity = mquantity
End Property

'##ModelId=3712CEBB02C6
Public Property Let quantity(ByVal Value As Integer)
    Let mquantity = Value
End Property
'##ModelId=3726706703CA
Public Function getInfoByOrderId(ByVal lOrderId As Long, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoByOrderIdErr
    
    Dim sData() As String
    Dim iIndex As Integer
    Dim oOrderLine As OrderLine
    
    getInfoByOrderId = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theOrderLineDT = New dtsvc.OrderLineDT
    Else
        Set theOrderLineDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.OrderLineDT")
    End If
    
    If theOrderLineDT.getInfoByOrderId(lOrderId, sData, sConnect, lErrno, sErrDescr) Then
       For iIndex = LBound(sData, giTWODIM) To UBound(sData, giTWODIM)
           If moInstanceInfo.objectContext Is Nothing Then
              Set oOrderLine = New brsvc.OrderLine
           Else
              Set oOrderLine = moInstanceInfo.objectContext.CreateInstance("brsvc.OrderLine")
           End If
           If unPack(oOrderLine, sData, sConnect, iIndex, True) Then
              getInfoByOrderId = True
              mcolOrderLine.Add oOrderLine, CStr(oOrderLine.orderLineId)
           End If
       Next
    End If
    
    Exit Function
      
        
getInfoByOrderIdErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=37267068001E
Public Function getState(sGetOrderLine() As String, sGetProduct() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
               
    ReDim sGetOrderLine(giOrderLineCount - 1, 0)
    ReDim sGetProduct(giProductCount - 1, 0)
    
    sGetOrderLine(giOrderLineId, 0) = orderLineId
    sGetOrderLine(giOrderLineOrderId, 0) = theOrder.orderId
    sGetOrderLine(giOrderLineProductId, 0) = theProduct.productId
    sGetOrderLine(giQuantity, 0) = quantity
    sGetOrderLine(giOrderLineDiscount, 0) = discount
    sGetOrderLine(giUnitPrice, 0) = extendedUnitPrice
    sGetOrderLine(giOrderLineISDeleted, 0) = isDeleted
    sGetOrderLine(giOrderLineISNew, 0) = isNew
    sGetOrderLine(giOrderLineISDirty, 0) = isDirty
    
    
    sGetProduct(giProductId, 0) = theProduct.productId
    sGetProduct(giProductDescription, 0) = theProduct.description
    sGetProduct(giPrice, 0) = theProduct.price
    sGetProduct(giProductDiscount, 0) = theProduct.discount
    sGetProduct(giQuantityOnHand, 0) = theProduct.quantityOnHand
    sGetProduct(giEoq, 0) = theProduct.eoq
    sGetProduct(giProductType, 0) = theProduct.productType
    sGetProduct(giProductISDeleted, 0) = theProduct.isDeleted
    sGetProduct(giProductISNew, 0) = theProduct.isNew
    sGetProduct(giProductISDirty, 0) = theProduct.isDirty
       
    getState = True
    
    Exit Function

getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=37267068008C
Private Function unPack(theOrderLine As OrderLine, sData() As String, ByVal sConnect As String, iIndex As Integer, Optional bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    Dim oProduct As Product
    Dim lProductId As Long
    Dim oProductObject As Object
       
    unPack = False
    
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theOrderLine.theOrder = New brsvc.Order
        Set theOrderLine.theProduct = New brsvc.Product
        Set oProduct = New brsvc.Product
    Else
        Set theOrderLine.theOrder = moInstanceInfo.objectContext.CreateInstance("brsvc.Order")
        Set theOrderLine.theProduct = moInstanceInfo.objectContext.CreateInstance("brsvc.Product")
        Set oProduct = moInstanceInfo.objectContext.CreateInstance("brsvc.Product")
    End If
    
    Set theOrderLine.theOrder = theOrder
        
    theOrderLine.orderLineId = CLng(sData(giOrderLineId, iIndex))
    theOrderLine.quantity = CInt(sData(giQuantity, iIndex))
    theOrderLine.discount = CCur(sData(giOrderLineDiscount, iIndex))
    theOrderLine.extendedUnitPrice = CCur(sData(giUnitPrice, iIndex))
           
    lProductId = CLng(sData(giOrderLineProductId, iIndex))
    
    If oProduct.getInfo(lProductId, sConnect, oProductObject, lErrno, sErrDescr) Then
       Set theOrderLine.theProduct = oProductObject.ProductObject
       unPack = True
    End If
           
    'If the unpack is the result of an inquiry then default
    'the state flags to false, else...use what was passed in
    'from the client
    If bInquiry Then
       theOrderLine.isDeleted = False
       theOrderLine.isNew = False
       theOrderLine.isDirty = False
    Else
       theOrderLine.isDeleted = sData(giOrderLineISDeleted, iIndex)
       theOrderLine.isNew = sData(giOrderLineISNew, iIndex)
       theOrderLine.isDirty = sData(giOrderLineISDirty, iIndex)
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726706800FA
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3726706800FB
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=37267068012C
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

