VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "OrderSummary"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D332D00D2"
Option Base 0
Option Explicit

'##ModelId=36E0C9730302
Private morderSummaryId As Long

'##ModelId=36E0C98B0262
Private mdiscount As Currency

'##ModelId=36E0C9B201EA
Private mcourtesyMessage As String

'##ModelId=3712B8D902BC
Private misNew As Boolean

'##ModelId=3712B8D902EE
Private misDirty As Boolean

'##ModelId=3712B8D902EF
Private misDeleted As Boolean

'##ModelId=368D334E03AC
Public theOrder As Order
'##ModelId=37267069030E
Private theOrderSummaryDT As dtsvc.OrderSummaryDT
Implements ObjectControl

'##ModelId=372670690311
Dim moInstanceInfo As InstanceUDT

'##ModelId=3712CEC2019A
Public Property Get isDeleted() As Boolean
   Let isDeleted = misDeleted
End Property

'##ModelId=3712CEC200BE
Public Property Let isDeleted(ByVal Value As Boolean)
    Let misDeleted = Value
End Property

'##ModelId=3712CEC20050
Public Property Get isDirty() As Boolean
   Let isDirty = misDirty
End Property

'##ModelId=3712CEC1035C
Public Property Let isDirty(ByVal Value As Boolean)
    Let misDirty = Value
End Property

'##ModelId=3712CEC102EE
Public Property Get isNew() As Boolean
   Let isNew = misNew
End Property

'##ModelId=3712CEC10212
Public Property Let isNew(ByVal Value As Boolean)
    Let misNew = Value
End Property

'##ModelId=3712CEC101A4
Public Property Get courtesyMessage() As String
   Let courtesyMessage = mcourtesyMessage
End Property

'##ModelId=3712CEC100C8
Public Property Let courtesyMessage(ByVal Value As String)
    Let mcourtesyMessage = Value
End Property

'##ModelId=3712CEC10028
Public Property Get discount() As Currency
   Let discount = mdiscount
End Property

'##ModelId=3712CEC00334
Public Property Let discount(ByVal Value As Currency)
    Let mdiscount = Value
End Property

'##ModelId=3712CEC002C6
Public Property Get orderSummaryId() As Long
   Let orderSummaryId = morderSummaryId
End Property

'##ModelId=3712CEC001EA
Public Property Let orderSummaryId(ByVal Value As Long)
    Let morderSummaryId = Value
End Property
'##ModelId=3726706A00DC
Public Function getInfoByOrderId(ByVal lOrderId As Long, Optional ByVal sConnect As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoByOrderIdErr
    
    Dim sData() As String
    
    getInfoByOrderId = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theOrderSummaryDT = New dtsvc.OrderSummaryDT
    Else
        Set theOrderSummaryDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.OrderSummaryDT")
    End If
    
    If theOrderSummaryDT.getInfoByOrderId(lOrderId, sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          getInfoByOrderId = True
          
       End If
    End If
    
    Exit Function
      
        
getInfoByOrderIdErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726706A014A
Public Function getState(sGetOrderSummary() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
        
    On Error GoTo getStateErr
        
    getState = False
    Dim i As Integer
            
    ReDim sGetOrderSummary(giOrderSummaryCount - 1, 0)
    
    sGetOrderSummary(giOrderSummaryId, 0) = orderSummaryId
    sGetOrderSummary(giOrderSummaryOrderId, 0) = theOrder.orderId
    sGetOrderSummary(giDiscount, 0) = discount
    sGetOrderSummary(giCourtesyMessage, 0) = courtesyMessage
    sGetOrderSummary(giOrderSummaryISDeleted, 0) = isDeleted
    sGetOrderSummary(giOrderSummaryISNew, 0) = isNew
    sGetOrderSummary(giOrderSummaryISDirty, 0) = isDirty
    
    getState = True
    Exit Function

getStateErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726706A0186
Private Function unPack(sData() As String, iIndex As Integer, Optional bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    orderSummaryId = CLng(sData(giOrderSummaryId, iIndex))
    discount = CCur(sData(giDiscount, iIndex))
    courtesyMessage = CStr(sData(giCourtesyMessage, iIndex))
       
    'If the unpack is the result of an inquiry then default
    'the state flags to false, else...use what was passed in
    'from the client
    If bInquiry Then
       isDeleted = False
       isNew = False
       isDirty = False
    Else
       isDeleted = sData(giOrderSummaryISDeleted, iIndex)
       isNew = sData(giOrderSummaryISNew, iIndex)
       isDirty = sData(giOrderSummaryISDirty, iIndex)
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726706A01F4
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3726706A01F5
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=3726706A0226
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

