VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Product"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D33B60244"
Option Base 0
Option Explicit

'##ModelId=36E0CA1200AA
Private mproductId As Long

'##ModelId=36E0CA1F03C0
Private mdescription As String

'##ModelId=36E0CA3503A2
Private mprice As Currency

'##ModelId=36E0CA5201B8
Private mdiscount As Currency

'##ModelId=36E0CA6B02BC
Private mquantityOnHand As Integer

'##ModelId=36E0CA92024E
Private meoq As Integer
'##ModelId=3726706D02A8
Private mproductType As Integer

'##ModelId=3712B8E20366
Private misNew As Boolean

'##ModelId=3712B8E20398
Private misDirty As Boolean

'##ModelId=3712B8E203D4
Private misDeleted As Boolean


'##ModelId=368D3F5C0033
Public theProduct2 As Product
'##ModelId=3726706D0318
Private theProductDT As dtsvc.ProductDT

'##ModelId=3726706D0352
Private mcolProduct As New Collection
Implements ObjectControl

'##ModelId=3726706D0386
Dim moInstanceInfo As InstanceUDT


'##ModelId=3712CEC903AC
Public Property Get isDeleted() As Boolean
   Let isDeleted = misDeleted
End Property

'##ModelId=3712CEC901B8
Public Property Let isDeleted(ByVal Value As Boolean)
    Let misDeleted = Value
End Property

'##ModelId=3712CEC9014A
Public Property Get isDirty() As Boolean
   Let isDirty = misDirty
End Property

'##ModelId=3712CEC80348
Public Property Let isDirty(ByVal Value As Boolean)
    Let misDirty = Value
End Property

'##ModelId=3712CEC802DA
Public Property Get isNew() As Boolean
   Let isNew = misNew
End Property

'##ModelId=3712CEC800F0
Public Property Let isNew(ByVal Value As Boolean)
    Let misNew = Value
End Property
'##ModelId=3726706E00E6
Public Property Get productType() As Integer
   Let productType = mproductType
End Property

'##ModelId=3726706E00B4
Public Property Let productType(ByVal Value As Integer)
    Let mproductType = Value
End Property
'##ModelId=3712CEC80082
Public Property Get eoq() As Integer
   Let eoq = meoq
End Property

'##ModelId=3712CEC70276
Public Property Let eoq(ByVal Value As Integer)
    Let meoq = Value
End Property

'##ModelId=3712CEC70208
Public Property Get quantityOnHand() As Integer
   Let quantityOnHand = mquantityOnHand
End Property

'##ModelId=3712CEC70050
Public Property Let quantityOnHand(ByVal Value As Integer)
    Let mquantityOnHand = Value
End Property

'##ModelId=3712CEC603CA
Public Property Get discount() As Currency
   Let discount = mdiscount
End Property

'##ModelId=3712CEC601E0
Public Property Let discount(ByVal Value As Currency)
    Let mdiscount = Value
End Property

'##ModelId=3712CEC60172
Public Property Get price() As Currency
   Let price = mprice
End Property

'##ModelId=3712CEC50366
Public Property Let price(ByVal Value As Currency)
    Let mprice = Value
End Property

'##ModelId=3712CEC502F8
Public Property Get description() As String
   Let description = mdescription
End Property

'##ModelId=3712CEC5010E
Public Property Let description(ByVal Value As String)
    Let mdescription = Value
End Property

'##ModelId=3712CEC500A0
Public Property Get productId() As Long
   Let productId = mproductId
End Property

'##ModelId=3712CEC4029E
Public Property Let productId(ByVal Value As Long)
    Let mproductId = Value
End Property
'##ModelId=3726706E0348
Public Function getInfo(ByVal lProductId As Long, Optional ByVal sConnect As String, Optional oRealProduct As Object, Optional lErrno As Long, Optional sErrDescr As String) As Boolean

    On Error GoTo getInfoErr
    
    Dim sData() As String
        
    Dim oICrud As ICrud
        
    getInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theProductDT = New dtsvc.ProductDT
    Else
        Set theProductDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.ProductDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theProductDT
    
    If oICrud.getInfo(CStr(lProductId), sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, sConnect, oRealProduct, giZERODIM, True) Then
          getInfo = True
            Exit Function
       End If
    End If
    
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=3726706F0000
Private Function unPack(sData() As String, ByVal sConnect As String, oRealProduct As Object, iIndex As Integer, Optional ByVal bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    Dim oGuitar As Guitar
    Dim oSheetMusic As SheetMusic
    Dim oSupplies As Supplies
    Dim oProduct As Product
    
    productType = CInt(sData(giProductType, iIndex))
    productId = CLng(sData(giProductId, iIndex))
    
    Select Case productType
        Case giTypeGuitar
        
            If moInstanceInfo.objectContext Is Nothing Then
                Set oGuitar = New brsvc.Guitar
            Else
                Set oGuitar = moInstanceInfo.objectContext.CreateInstance("brsvc.Guitar")
            End If
            
            Set oProduct = oGuitar
            
            'talk to the product interface
            If oProduct.getInfo(productId, sConnect, , lErrno, sErrDescr) Then
               unPack = True
               Set oRealProduct = oGuitar
            Else
               unPack = False
            End If
            
        Case giTypeSheetMusic
        
            If moInstanceInfo.objectContext Is Nothing Then
                Set oSheetMusic = New brsvc.SheetMusic
            Else
                Set oSheetMusic = moInstanceInfo.objectContext.CreateInstance("brsvc.SheetMusic")
            End If
            
            Set oProduct = oSheetMusic
            
            'talk to the product interface
            If oProduct.getInfo(productId, sConnect, , lErrno, sErrDescr) Then
               unPack = True
               Set oRealProduct = oSheetMusic
            Else
               unPack = False
            End If
            
        Case giTypeSupplies
        
            If moInstanceInfo.objectContext Is Nothing Then
                Set oSupplies = New brsvc.Supplies
            Else
                Set oSupplies = moInstanceInfo.objectContext.CreateInstance("brsvc.Supplies")
            End If
            
            Set oProduct = oSupplies
            
            'talk to the product interface
            If oProduct.getInfo(productId, sConnect, , lErrno, sErrDescr) Then
               unPack = True
               Set oRealProduct = oSupplies
            Else
               unPack = False
            End If
    End Select
    
    
            
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=3726706F00DC
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=3726706F0118
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=3726706F014A
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

