VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "SheetMusic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"368D33CB000A"
Option Base 0
Option Explicit
Implements Product

'local superclass object (generated)
'##ModelId=36E556C5003C
Private mProductObject As New Product

'##ModelId=3712613C0140
Private msheetId As Long

'##ModelId=371261E301CC
Private mpages As Integer
'##ModelId=3726707700C0
Private theSheetMusicDT As dtsvc.SheetMusicDT
Implements ObjectControl

'##ModelId=3726707700F2
Dim moInstanceInfo As InstanceUDT

'##ModelId=3726707700F3
Private Function Product_getInfo(ByVal lProductId As Long, Optional ByVal sConnect As String, Optional oRealProduct As Object, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    On Error GoTo getInfoErr
    
    Dim sData() As String
        
    Dim oICrud As ICrud
        
    Product_getInfo = False
    
    If moInstanceInfo.objectContext Is Nothing Then
        Set theSheetMusicDT = New dtsvc.SheetMusicDT
    Else
        Set theSheetMusicDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.SheetMusicDT")
    End If
    
    'Talk to the DT interface
    Set oICrud = theSheetMusicDT
    
    If oICrud.getInfo(CStr(lProductId), sData, sConnect, lErrno, sErrDescr) Then
       If unPack(sData, giZERODIM, True) Then
          Product_getInfo = True
          Exit Function
       End If
    End If
    
getInfoErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=37267077015E
Private Property Let Product_productType(ByVal RHS As Integer)
    mProductObject.productType = RHS
End Property

'##ModelId=37267077019A
Private Property Get Product_productType() As Integer
    Product_productType = mProductObject.productType()
End Property



'##ModelId=3712CEDA01A4
Private Property Set Product_theProduct2(ByVal RHS As Product)
    Set mProductObject.theProduct2 = RHS
End Property

'##ModelId=3712CEDA0136
Private Property Get Product_theProduct2() As Product
    Set Product_theProduct2 = mProductObject.theProduct2
End Property

'##ModelId=3712CEDA008C
Private Property Let Product_theProduct2(RHS As Variant)
    Let mProductObject.theProduct2 = RHS
End Property

'##ModelId=3712CEDA001E
Private Property Get Product_isDeleted() As Boolean
    Product_isDeleted = mProductObject.isDeleted()
End Property

'##ModelId=3712CED9032A
Private Property Let Product_isDeleted(ByVal Value As Boolean)
    mProductObject.isDeleted = Value
End Property

'##ModelId=3712CED902BC
Private Property Get Product_isDirty() As Boolean
    Product_isDirty = mProductObject.isDirty()
End Property

'##ModelId=3712CED9021C
Private Property Let Product_isDirty(ByVal Value As Boolean)
    mProductObject.isDirty = Value
End Property

'##ModelId=3712CED901AE
Private Property Get Product_isNew() As Boolean
    Product_isNew = mProductObject.isNew()
End Property

'##ModelId=3712CED900D2
Private Property Let Product_isNew(ByVal Value As Boolean)
    mProductObject.isNew = Value
End Property

'##ModelId=3712CED90096
Private Property Get Product_eoq() As Integer
    Product_eoq = mProductObject.eoq()
End Property

'##ModelId=3712CED803A2
Private Property Let Product_eoq(ByVal Value As Integer)
    mProductObject.eoq = Value
End Property

'##ModelId=3712CED80334
Private Property Get Product_quantityOnHand() As Integer
    Product_quantityOnHand = mProductObject.quantityOnHand()
End Property

'##ModelId=3712CED80294
Private Property Let Product_quantityOnHand(ByVal Value As Integer)
    mProductObject.quantityOnHand = Value
End Property

'##ModelId=3712CED80226
Private Property Get Product_discount() As Currency
    Product_discount = mProductObject.discount()
End Property

'##ModelId=3712CED8014A
Private Property Let Product_discount(ByVal Value As Currency)
    mProductObject.discount = Value
End Property

'##ModelId=3712CED800DC
Private Property Get Product_price() As Currency
    Product_price = mProductObject.price()
End Property

'##ModelId=3712CED80032
Private Property Let Product_price(ByVal Value As Currency)
    mProductObject.price = Value
End Property

'##ModelId=3712CED703AC
Private Property Get Product_description() As String
    Product_description = mProductObject.description()
End Property

'##ModelId=3712CED702D0
Private Property Let Product_description(ByVal Value As String)
    mProductObject.description = Value
End Property

'##ModelId=3712CED70262
Private Property Get Product_productId() As Long
    Product_productId = mProductObject.productId()
End Property

'##ModelId=3712CED70186
Private Property Let Product_productId(ByVal Value As Long)
    mProductObject.productId = Value
End Property

'##ModelId=3712CED7000A
Public Property Get pages() As Integer
   Let pages = mpages
End Property

'##ModelId=3712CED60352
Public Property Let pages(ByVal Value As Integer)
    Let mpages = Value
End Property

'##ModelId=3712CED602E4
Public Property Get sheetId() As Long
   Let sheetId = msheetId
End Property

'##ModelId=3712CED6023A
Public Property Let sheetId(ByVal Value As Long)
    Let msheetId = Value
End Property

'##ModelId=3712CED6019A
Public Property Get ProductObject() As Product
    Set ProductObject = mProductObject
End Property

'##ModelId=3712CED600F0
Public Property Set ProductObject(ByVal Value As Product)
    Set mProductObject = Value
End Property

'##ModelId=3712CED60050
Public Property Let ProductObject(ByVal Value As Product)
    Let mProductObject = Value
End Property

    
'##ModelId=3726707801F4
Private Function unPack(sData() As String, iIndex As Integer, Optional bInquiry As Boolean, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo unPackErr
    
    unPack = False
    
    
    pages = CInt(sData(giPages, iIndex))
    sheetId = CLng(sData(giSheetMusicId, iIndex))
    
    'set superclass values
    Product_productId = CLng(sData(giSheetMusicProductId, iIndex))
    Product_description = CStr(sData(giSheetMusicDescription, iIndex))
    Product_price = CCur(sData(giSheetMusicPrice, iIndex))
    Product_discount = CCur(sData(giSheetMusicDiscount, iIndex))
    Product_quantityOnHand = CInt(sData(giSheetMusicQuantityOnHand, iIndex))
    Product_eoq = CInt(sData(giSheetMusicEoq, iIndex))
    Product_productType = CLng(sData(giSheetMusicProductType, iIndex))
    
    'If the unpack is the result of an inquiry then default
    'the state flags to false, else...use what was passed in
    'from the client
    If bInquiry Then
       Product_isDeleted = False
       Product_isNew = False
       Product_isDirty = False
    Else
       Product_isDeleted = sData(giSheetMusicISDeleted, iIndex)
       Product_isNew = sData(giSheetMusicISNew, iIndex)
       Product_isDirty = sData(giSheetMusicISDirty, iIndex)
    End If
        
    unPack = True
    Exit Function
    
unPackErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function
'##ModelId=372670780262
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=372670780263
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=37267078029E
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
