VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 4  'RequiresNewTransaction
END
Attribute VB_Name = "UCProcessOrderController"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F71FDB01C2"
'##ModelId=3726705E03C0
Private Const msDSN As String = "DSN=remulakcappucino;UID=remulak;PWD=remulak;"
'Private Const msDSN As String = "DSN=remulaklatte;UID=remulak;PWD=remulak;"

Implements ObjectControl

'##ModelId=3726705E03C3
Dim moInstanceInfo As InstanceUDT
'##ModelId=3726705F0014
Public Function OrderInquiry(ByVal sOrderNumber As String, sDataOrder() As String, sDataOrderHeader() As String, sDataOrderLine() As String, sDataProduct() As String, sDataOrderSummary() As String, sDataCustomer() As String, Optional lErrno As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo OrderInquiryErr
    
    OrderInquiry = False
    
    'MTS Check
    If moInstanceInfo.objectContext Is Nothing Then
       Set oContextDT = New dtsvc.ContextDT
       Set oOrder = New Order
    Else 'MTS present
       Set oContextDT = moInstanceInfo.objectContext.CreateInstance("dtsvc.ContextDT")
       Set oOrder = moInstanceInfo.objectContext.CreateInstance("brsvc.Order")
    End If
    
    If oContextDT.DTSetContext(msDSN, False, lErrno, sErrDescr) Then
       If oOrder.getInfo(sOrderNumber, True, msDSN, lErrno, sErrDescr) Then
          If oOrder.getState(sDataOrder, sDataOrderHeader, sDataOrderLine, sDataProduct, sDataOrderSummary, sDataCustomer, lErrno, sErrDescr) Then
          
            OrderInquiry = True
            
            Set oOrder = Nothing
            
          End If
        End If
    End If
    
    'if all went well
    If OrderInquiry Then
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTSetComplete(False, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             OrderInquiry = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetComplete
          Exit Function
       End If
    Else 'troubles ahead
       'If MTS isn't running
       If moInstanceInfo.objectContext Is Nothing Then
          If oContextDT.DTsetAbort(False, lErrno, sErrDescr) Then
             Set oContextDT = Nothing
             Exit Function
          Else
             OrderInquiry = False
          End If
       Else 'MTS is running
          moInstanceInfo.objectContext.SetAbort
          Exit Function
       End If
    End If
        
OrderInquiryErr:
    lErrno = Err.Number
    sErrDescr = Err.description
End Function

'##ModelId=3726705F0046
Private Sub ObjectControl_Activate()
   Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3726705F0047
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function

'##ModelId=3726705F0082
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

