VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "LocaleDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08DDE017C"
Option Base 0
Option Explicit
Implements ICrud

'##ModelId=36F0B04902EF
Public theAccess As Access
'##ModelId=36FDCEDC0140
Private Const msLocale As String = "T_Locale"
Implements ObjectControl
'##ModelId=3712432A0084
Dim moInstanceInfo As InstanceUDT


'##ModelId=36F15D7A01EB
Private Function ICrud_getInfo(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
        
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "mlocaleID" & gsCOMMASPACE
    sQry = sQry & "mcustomerId" & gsCOMMASPACE
    sQry = sQry & "maddressId" & gsCOMMASPACE
    sQry = sQry & "mrole"
    sQry = sQry & gsFROM
    sQry = sQry & msLocale
    sQry = sQry & gsWHERE
    sQry = sQry & "mcustomerId" & gsEQUALS
    sQry = sQry & CLng(sQualifier)
    
            
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function


'##ModelId=36F15D7A01B0
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...
    GetStatus
    SetStatus
End Function

'##ModelId=36F15D7A01AE
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...
    GetStatus
    SetStatus
End Function

'##ModelId=36F15D7A017C
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
   
    Dim sQry As String
    
    ICrud_insert = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsINSERT & gsINTO
    sQry = sQry & msLocale & gsSPACE
    sQry = sQry & gsOP & "mlocaleId" & gsCOMMASPACE
    sQry = sQry & "mcustomerId" & gsCOMMASPACE
    sQry = sQry & "maddressId" & gsCOMMASPACE
    sQry = sQry & "mrole"
    sQry = sQry & gsCP
    sQry = sQry & gsVALUES & gsOP
    sQry = sQry & sData(giLocaleId, 0) & gsCOMMASPACE
    sQry = sQry & sData(giLocaleCustomerId, 0) & gsCOMMASPACE
    sQry = sQry & sData(giLocaleAddressId, 0) & gsCOMMASPACE
    sQry = sQry & sData(giRole, 0)
    sQry = sQry & gsCP
            
    'Call the operation on the Access class
    If theAccess.DAQuery(sQry, sConnect, lErrNo, sErrDescr) Then
        ICrud_insert = True
    End If
    
    'ReDim the dimension so the data doesn't get passed back
    ReDim sData(0, 0)
    
    SetStatus

End Function
'If MTS is running, then set theAccess with new access
'##ModelId=3712432A0200
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object
'##ModelId=3712432A023A
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub
'##ModelId=3712432A023B
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3712432A026C
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3712432A02A8
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
