VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "OrderHeaderDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08E4103C0"
Option Base 0
Option Explicit
Implements ICrud

'##ModelId=36F0B0450169
Public theAccess As Access
'##ModelId=372671380050
Private Const msOrderHeader As String = "T_OrderHeader"
Implements ObjectControl

'##ModelId=37267138008E
Dim moInstanceInfo As InstanceUDT

'##ModelId=36F15D83003D
Private Function ICrud_getInfo(ByVal sQualifier As String, sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus
    
        
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "morderHeaderID" & gsCOMMASPACE
    sQry = sQry & "morderId" & gsCOMMASPACE
    sQry = sQry & "mdate" & gsCOMMASPACE
    sQry = sQry & "mterms" & gsCOMMASPACE
    sQry = sQry & "msalesPerson"
    sQry = sQry & gsFROM
    sQry = sQry & msOrderHeader
    sQry = sQry & gsWHERE
    sQry = sQry & "morderHeaderId" & gsEQUALS
    sQry = sQry & CLng(sQualifier)
                
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function

'##ModelId=36F15D830002
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D830000
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D8203B6
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function
'##ModelId=372671380209
Public Function getInfoByOrderId(ByVal lOrderId As Long, sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    getInfoByOrderId = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "morderHeaderID" & gsCOMMASPACE
    sQry = sQry & "morderId" & gsCOMMASPACE
    sQry = sQry & "morderDateTime" & gsCOMMASPACE
    sQry = sQry & "mterms" & gsCOMMASPACE
    sQry = sQry & "msalesPerson"
    sQry = sQry & gsFROM
    sQry = sQry & msOrderHeader
    sQry = sQry & gsWHERE
    sQry = sQry & "morderId" & gsEQUALS
    sQry = sQry & lOrderId
                
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        getInfoByOrderId = True
    End If
    
    SetStatus
    
End Function
'If MTS is running, then set theAccess with new access
'##ModelId=372671380276
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object
'##ModelId=3726713802E4
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub

'##ModelId=372671380320
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=372671380352
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=372671380353
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub

