VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "OrderSummaryDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08DD600FA"
Option Base 0
Option Explicit
Implements ICrud

'##ModelId=36F0B0670385
Public theAccess As Access
'##ModelId=372671170384
Private Const msOrderSummary As String = "T_OrderSummary"
Implements ObjectControl

'##ModelId=3726711703B8
Dim moInstanceInfo As InstanceUDT

'##ModelId=36F15D7901F6
Private Function ICrud_getInfo(ByVal sQualifier As String, sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    ICrud_getInfo = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "morderSummaryID" & gsCOMMASPACE
    sQry = sQry & "morderId" & gsCOMMASPACE
    sQry = sQry & "mdiscount" & gsCOMMASPACE
    sQry = sQry & "mcourtesyMessage"
    sQry = sQry & gsFROM
    sQry = sQry & msOrderSummary
    sQry = sQry & gsWHERE
    sQry = sQry & "morderSummaryId" & gsEQUALS
    sQry = sQry & CLng(sQualifier)
                
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        ICrud_getInfo = True
    End If
    
    SetStatus
    
End Function

'##ModelId=36F15D7901F4
Private Function ICrud_delete(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D7901B8
Private Function ICrud_update(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function

'##ModelId=36F15D790186
Private Function ICrud_insert(ByVal sQualifier As String, ByRef sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    'your code goes here...


End Function
'##ModelId=372671180154
Public Function getInfoByOrderId(ByVal lOrderId As Long, sData() As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    Dim sQry As String
    
    getInfoByOrderId = False
    
    GetStatus
    
    '=======================================================================
    'Build query string
    
    sQry = gsSELECT
    sQry = sQry & "morderSummaryID" & gsCOMMASPACE
    sQry = sQry & "morderId" & gsCOMMASPACE
    sQry = sQry & "mdiscount" & gsCOMMASPACE
    sQry = sQry & "mcourtesyMessage"
    sQry = sQry & gsFROM
    sQry = sQry & msOrderSummary
    sQry = sQry & gsWHERE
    sQry = sQry & "morderId" & gsEQUALS
    sQry = sQry & lOrderId
                
    'Call the operation on the Access class
    If theAccess.DARetrieve(sQry, sData, False, sConnect, lErrNo, sErrDescr) Then
        getInfoByOrderId = True
    End If
    
    SetStatus
    
End Function
'If MTS is running, then set theAccess with new access
'##ModelId=372671180230
Private Sub GetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        Set theAccess = moInstanceInfo.objectContext.CreateInstance("dasvc.Access")
    Else
        Set theAccess = New Access
        Set theAccess = goAccess
    End If
End Sub
'If MTS is running, then call setComplete to Deactivate object
'##ModelId=372671180231
Private Sub SetStatus()
    If Not moInstanceInfo.objectContext Is Nothing Then
        moInstanceInfo.objectContext.SetComplete
    End If
End Sub

'##ModelId=372671180262
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub


'##ModelId=372671180263
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=37267118029E
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub


