VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UIProcessOrderController"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36F08E940014"
Option Base 0
Option Explicit

'##ModelId=372671710098
Public moUCProcessOrderController As brsvc.UCProcessOrderController
'##ModelId=3726717100D4
Public moUtility As New Utility
'these collections are for clients to get information
'##ModelId=372671710104
Public mcolCustomer As New Collection
'##ModelId=372671710105
Public mcolLocale As New Collection
'##ModelId=372671710140
Public mcolAddress As New Collection
'##ModelId=372671710172
Public mcolRole As New Collection
'##ModelId=372671710173
Public mcolOrder As New Collection
'##ModelId=3726717101AE
Public mcolOrderHeader As New Collection
'##ModelId=3726717101E0
Public mcolOrderSummary As New Collection
'##ModelId=3726717101E1
Public mcolOrderLine As New Collection
'##ModelId=37267171021C
Public mcolProduct As New Collection

'these dynamic arrays are for sending out to be populated
'##ModelId=37267171024E
Private msCustomerData() As String
'##ModelId=37267171024F
Private msLocaleData() As String
'##ModelId=37267171028A
Private msAddressData() As String
'##ModelId=3726717102BC
Private msOrderData() As String
'##ModelId=3726717102F8
Private msOrderSummaryData() As String
'##ModelId=3726717102F9
Private msOrderHeaderData() As String
'##ModelId=37267171032A
Private msOrderLineData() As String
'##ModelId=372671710366
Public Function getInfo(ByVal sOrderNumber As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo getInfoErr
    
    Dim customerInfo As CustomerUDT
    Dim localeInfo As LocaleUDT
    Dim AddressInfo As AddressUDT
    Dim OrderInfo As OrderUDT
    Dim OrderHeaderInfo As OrderHeaderUDT
    Dim OrderSummaryInfo As OrderSummaryUDT
    Dim OrderLineInfo As OrderLineUDT
    Dim ProductInfo As ProductUDT
    
    
    
    Dim sDataLocale() As String
    Dim sDataAddress() As String
    Dim sDataCustomer() As String
    Dim sDataOrder() As String
    Dim sDataOrderHeader() As String
    Dim sDataOrderSummary() As String
    Dim sDataOrderLine() As String
    Dim sDataProduct() As String
    
    Dim iIndex As Integer
        
    getInfo = False
    
    Set moUCProcessOrderController = New brsvc.UCProcessOrderController
        
    If moUCProcessOrderController.OrderInquiry(sOrderNumber, sDataOrder, sDataOrderHeader, sDataOrderLine, sDataProduct, sDataOrderSummary, sDataCustomer, lErrNo, sErrDescr) Then
       moUtility.freeCollection mcolOrder
       
       For iIndex = LBound(sDataOrder, giTWODIM) To UBound(sDataOrder, giTWODIM)
        
           With OrderInfo
                .orderId = CLng(sDataOrder(giOrderId, iIndex))
                .orderNumber = CStr(sDataOrder(giOrderNumber, iIndex))
                .invoiceId = CLng(sDataOrder(giInvoiceId, iIndex))
                .customerId = CLng(sDataOrder(giOrderCustomerId, iIndex))
                .isDeleted = False
                .isNew = False
                .isDirty = False
           End With
            
           mcolOrder.Add OrderInfo, CStr(OrderInfo.orderId)
       Next
             
       moUtility.freeCollection mcolCustomer
       For iIndex = LBound(sDataCustomer, giTWODIM) To UBound(sDataCustomer, giTWODIM)
        
           With customerInfo
                .customerId = CLng(sDataCustomer(giCustomerId, iIndex))
                .customerNumber = CStr(sDataCustomer(giCustomerNumber, iIndex))
                .firstName = CStr(sDataCustomer(giFirstName, iIndex))
                .lastName = CStr(sDataCustomer(giLastName, iIndex))
                .middleInitial = CStr(sDataCustomer(giMiddleInitial, iIndex))
                .prefix = CStr(sDataCustomer(giPrefix, iIndex))
                .suffix = CStr(sDataCustomer(giSuffix, iIndex))
                .phone1 = CStr(sDataCustomer(giPhone1, iIndex))
                .phone2 = CStr(sDataCustomer(giPhone2, iIndex))
                .eMail = CStr(sDataCustomer(giEMail, iIndex))
                .isDeleted = False
                .isNew = False
                .isDirty = False
           End With
            
           mcolCustomer.Add customerInfo, CStr(customerInfo.customerId)
        Next
        
        moUtility.freeCollection mcolOrderHeader
        
        For iIndex = LBound(sDataOrderHeader, giTWODIM) To UBound(sDataOrderHeader, giTWODIM)
        
           With OrderHeaderInfo
                .orderHeaderId = CLng(sDataOrderHeader(giOrderHeaderId, iIndex))
                .orderId = CLng(sDataOrderHeader(giOrderHeaderOrderId, iIndex))
                .date = CDate(sDataOrderHeader(giDate, iIndex))
                .terms = CStr(sDataOrderHeader(giTerms, iIndex))
                .salesPerson = CStr(sDataOrderHeader(giSalesPerson, iIndex))
                .isDeleted = False
                .isNew = False
                .isDirty = False
           End With
            
           mcolOrderHeader.Add OrderHeaderInfo, CStr(OrderHeaderInfo.orderHeaderId)
        Next
        
        moUtility.freeCollection mcolOrderSummary
        
        For iIndex = LBound(sDataOrderSummary, giTWODIM) To UBound(sDataOrderSummary, giTWODIM)
        
           With OrderSummaryInfo
                .orderSummaryId = CLng(sDataOrderSummary(giOrderSummaryId, iIndex))
                .orderId = CLng(sDataOrderSummary(giOrderSummaryOrderId, iIndex))
                .discount = CCur(sDataOrderSummary(giDiscount, iIndex))
                .courtesyMessage = CStr(sDataOrderSummary(giCourtesyMessage, iIndex))
                .isDeleted = False
                .isNew = False
                .isDirty = False
           End With
            
           mcolOrderSummary.Add OrderSummaryInfo, CStr(OrderSummaryInfo.orderSummaryId)
        Next
        
        moUtility.freeCollection mcolOrderLine
        
        For iIndex = LBound(sDataOrderLine, giTWODIM) To UBound(sDataOrderLine, giTWODIM)
        
           With OrderLineInfo
           
                .orderLineId = CLng(sDataOrderLine(giOrderLineId, iIndex))
                .orderId = CLng(sDataOrderLine(giOrderLineOrderId, iIndex))
                .productId = CLng(sDataOrderLine(giOrderLineProductId, iIndex))
                .quantity = CInt(sDataOrderLine(giQuantity, iIndex))
                .discount = CCur(sDataOrderLine(giOrderLineDiscount, iIndex))
                .unitPrice = CCur(sDataOrderLine(giUnitPrice, iIndex))
                .isDeleted = False
                .isNew = False
                .isDirty = False
           End With
            
           mcolOrderLine.Add OrderLineInfo, CStr(OrderLineInfo.orderLineId)
        Next
        
        moUtility.freeCollection mcolProduct
        
        For iIndex = LBound(sDataProduct, giTWODIM) To UBound(sDataProduct, giTWODIM)
        
           With ProductInfo
           
                .productId = CLng(sDataProduct(giProductId, iIndex))
                .description = CStr(sDataProduct(giProductDescription, iIndex))
                .price = CCur(sDataProduct(giPrice, iIndex))
                .discount = CCur(sDataProduct(giProductDiscount, iIndex))
                .quantityOnHand = CInt(sDataProduct(giQuantityOnHand, iIndex))
                .eoq = CInt(sDataProduct(giEoq, iIndex))
                .productType = CInt(sDataProduct(giProductType, iIndex))
                .isDeleted = False
                .isNew = False
                .isDirty = False
                           
           End With
            
           mcolProduct.Add ProductInfo, CStr(ProductInfo.productId)
        Next
                
        getInfo = True
        
           
        Set moUCProcessOrderController = Nothing
        
        ReDim sDataAddress(0, 0)
        ReDim sDataCustomer(0, 0)
        ReDim sDataLocale(0, 0)
        ReDim sDataOrder(0, 0)
        ReDim sDataOrderLine(0, 0)
        ReDim sDataOrderSummary(0, 0)
        ReDim sDataOrderHeader(0, 0)
        ReDim sDataProduct(0, 0)
               
        Exit Function
    End If
        
getInfoErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
'returns order info as variants for scripting clients
'##ModelId=372671710398
Public Function getOrderByParm(vOrderId As Variant, vOrderNumber As Variant, vInvoiceId As Variant, vCustomerId As Variant, Optional vErrNo As Variant, Optional vErrDescr As Variant) As Boolean
    On Error GoTo getOrderByParmErr
    
    getOrderByParm = False
    
    vOrderId = mcolOrder(1).orderId
    vOrderNumber = mcolOrder(1).orderNumber
    vInvoiceId = mcolOrder(1).invoiceId
    vCustomerId = mcolOrder(1).customerId
        
    getOrderByParm = True
    
    Exit Function
        
getOrderByParmErr:
    vErrNo = Err.Number
    vErrDescr = Err.description
End Function
'returns order header info as variants for scripting clients
'##ModelId=37267172001E
Public Function getOrderHeaderByParm(vOrderHeaderId As Variant, vOrderId As Variant, vDate As Variant, vTerms As Variant, vSalesPerson As Variant, Optional vErrNo As Variant, Optional vErrDescr As Variant) As Boolean
    On Error GoTo getOrderHeaderByParmErr
    
    getOrderHeaderByParm = False
    
    vOrderHeaderId = mcolOrderHeader(1).orderHeaderId
    vOrderId = mcolOrderHeader(1).orderId
    vDate = mcolOrderHeader(1).date
    vTerms = mcolOrderHeader(1).terms
    vSalesPerson = mcolOrderHeader(1).salesPerson
        
    getOrderHeaderByParm = True
    
    Exit Function
        
getOrderHeaderByParmErr:
    vErrNo = Err.Number
    vErrDescr = Err.description
End Function
'returns order line info as variants for scripting clients
'##ModelId=37267172005B
Public Function getOrderLineByParm(vIndex As Variant, vOrderLineId As Variant, vOrderId As Variant, vProductId As Variant, vQuantity As Variant, vDiscount As Variant, vUnitPrice As Variant, Optional vErrNo As Variant, Optional vErrDescr As Variant) As Boolean
    On Error GoTo getOrderLineByParmErr
    
    getOrderLineByParm = False
    
    vOrderLineId = mcolOrderLine(vIndex).orderLineId
    vOrderId = mcolOrderLine(vIndex).orderId
    vProductId = mcolOrderLine(vIndex).productId
    vQuantity = mcolOrderLine(vIndex).quantity
    vDiscount = mcolOrderLine(vIndex).discount
    vUnitPrice = mcolOrderLine(vIndex).unitPrice
            
    getOrderLineByParm = True
    
    Exit Function
        
getOrderLineByParmErr:
    vErrNo = Err.Number
    vErrDescr = Err.description
End Function
'returns product info as variants for scripting clients
'##ModelId=3726717200FA
Public Function getProductByParm(vIndex As Variant, vProductId As Variant, vDescription As Variant, vPrice As Variant, vDiscount As Variant, vQuantityOnHand As Variant, vEoq As Variant, vProductType As Variant, Optional vErrNo As Variant, Optional vErrDescr As Variant) As Boolean
    On Error GoTo getProductByParmErr
    
    getProductByParm = False
    
    vProductId = mcolProduct(vIndex).productId
    vDescription = mcolProduct(vIndex).description
    vPrice = mcolProduct(vIndex).price
    vDiscount = mcolProduct(vIndex).discount
    vQuantityOnHand = mcolProduct(vIndex).quantityOnHand
    vEoq = mcolProduct(vIndex).eoq
    vProductType = mcolProduct(vIndex).productType
            
    getProductByParm = True
    
    Exit Function
        
getProductByParmErr:
    vErrNo = Err.Number
    vErrDescr = Err.description
End Function
'returns order summary info as variants for scripting clients
'##ModelId=372671720168
Public Function getOrderSummaryByParm(vOrderSummaryId As Variant, vOrderId As Variant, vDiscount As Variant, vCourtesyMessage As Variant, Optional vErrNo As Variant, Optional vErrDescr As Variant) As Boolean
    On Error GoTo getOrderSummaryByParmErr
    
    getOrderSummaryByParm = False
    
    vOrderSummaryId = mcolOrderSummary(1).orderLineId
    vOrderId = mcolOrderSummary(1).orderId
    vDiscount = mcolOrderSummary(1).discount
    vCourtesyMessage = mcolOrderSummary(1).courtesyMessage
            
   getOrderSummaryByParm = True
    
    Exit Function
        
getOrderSummaryByParmErr:
    vErrNo = Err.Number
    vErrDescr = Err.description
End Function
'returns customer info as variants for scripting clients
'##ModelId=3726717201D6
Public Function getCustomerByParm(vCustomerId As Variant, vCustomerNumber As Variant, vFirstName As Variant, vLastName As Variant, vMiddleInitial As Variant, vPrefix As Variant, vSuffix As Variant, vPhone1 As Variant, vPhone2 As Variant, vEmail As Variant, Optional vErrNo As Variant, Optional vErrDescr As Variant) As Boolean
    On Error GoTo getCustomerByParmErr
    
    getCustomerByParm = False
    
    vCustomerId = mcolCustomer(1).customerId
    vCustomerNumber = mcolCustomer(1).customerNumber
    vFirstName = mcolCustomer(1).firstName
    vLastName = mcolCustomer(1).lastName
    vMiddleInitial = mcolCustomer(1).middleInitial
    vPrefix = mcolCustomer(1).prefix
    vSuffix = mcolCustomer(1).suffix
    vPhone1 = mcolCustomer(1).phone1
    vPhone2 = mcolCustomer(1).phone2
    vEmail = mcolCustomer(1).eMail
            
    getCustomerByParm = True
    
    Exit Function
        
getCustomerByParmErr:
    vErrNo = Err.Number
    vErrDescr = Err.description
End Function
