Attribute VB_Name = "uiBas"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36FDCF150078"

'##ModelId=36FDCF150118
Public Sub Main()
    frmRemulakMDI.Show
End Sub
'Handle error conditions, message box and focus
'##ModelId=3703E8620000
Public Sub setMessage(cntlControl As Control, ByVal sMessage As String, ByVal sTitle As String)
    MsgBox sMessage, , sTitle
    cntlControl.SetFocus
    setMessageTxt = True
End Sub

'Fills a combo box based on a string array passed in
'##ModelId=370003D40262
Public Function fillComboBox(cmbCombo As ComboBox, sData() As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    Dim iIndex As Integer
    Dim sTemp As String
    Dim iTemp As String
    
    On Error GoTo fillComboBoxErr
    fillComboBox = False
    
    For iIndex = cmbCombo.ListCount - 1 To 0 Step -1
        cmbCombo.RemoveItem (iIndex)
    Next iIndex
     
    For iIndex = LBound(sData, giTWODIM) To UBound(sData, giTWODIM)
        sTemp = sData(giDescription, iIndex)
        iTemp = sData(giCode, iIndex)
        cmbCombo.AddItem sTemp
        cmbCombo.ItemData(cmbCombo.NewIndex) = iTemp
    Next
            
    fillComboBox = True
    Exit Function
fillComboBoxErr:
    lErrNo = Err.Number
    sErrDescr = Err.description
End Function
''Frees a collection
''##ModelId=370003D40267
'Public Sub freeCollection(colTemp As Collection)
'    Dim i As Integer
'    If colTemp Is Nothing Then
'        Exit Sub
'    End If
'    i = 1
'    Do While i <= colTemp.Count
'        colTemp.Remove i
'    Loop
'End Sub
'Checks to see if a key is in a collection
'##ModelId=370003D40294
Public Function checkCollection(ByVal colTemp As Collection, ByVal sTemp As String) As Boolean
    Dim vResult As Variant
    
    On Error GoTo CheckCollectionErr
    checkCollection = False
    If IsObject(colTemp.Item(sTemp)) Then
        Set vResult = colTemp.Item(sTemp)
    Else
        vResult = colTemp.Item(sTemp)
    End If
    checkCollection = True
    
    On Error GoTo 0
    Exit Function
CheckCollectionErr:

End Function
'Select the first item of combo box
'##ModelId=370003D40297
Public Sub selectFirstItemOfComboBox(cmbItem As ComboBox)
    If cmbItem.ListCount > 0 Then
        cmbItem.ListIndex = 0
    End If
End Sub
'Select the first item of a list box
'##ModelId=370003D402D0
Public Sub selectFirstItemOfListBox(lstItem As ListBox)
    If lstItem.ListCount > 0 Then
        lstItem.Selected(0) = True
    End If
End Sub
'Select a Given Item from a list box
'##ModelId=370003D402D2
Public Sub selectGivenItemOfListBox(lstItem As ListBox, sItem As String, Optional bSkipDisplayDetails As Boolean)
    Dim iIndex As Integer
    For iIndex = 0 To lstItem.ListCount - 1
        bSkipDisplayDetails = True
        If lstItem.List(iIndex) = sItem Then
            lstItem.Selected(iIndex) = True
        Else
            lstItem.Selected(iIndex) = False
        End If
    Next
End Sub
'Select a Given Item by List Value from a combo box
'##ModelId=370003D40370
Public Sub selectGivenItemOfComboBox(cmbItem As ComboBox, sItem As String, Optional bSkipDisplayDetails As Boolean)
    Dim iIndex As Integer
    For iIndex = 0 To cmbItem.ListCount - 1
        bSkipDisplayDetails = True
        If cmbItem.List(iIndex) = sItem Then
            cmbItem.ListIndex = iIndex
        End If
    Next
End Sub
'Select a Given Item by ItemData from a combo box
'##ModelId=370003D40374
Public Sub selectGivenItemDataOfComboBox(cmbItem As ComboBox, sItem As String, Optional bSkipDisplayDetails As Boolean)
    Dim iIndex As Integer
    For iIndex = 0 To cmbItem.ListCount - 1
        bSkipDisplayDetails = True
        If cmbItem.ItemData(iIndex) = sItem Then
            cmbItem.ListIndex = iIndex
        End If
    Next
End Sub
'Selects the list index of an item in a combo box
'##ModelId=370003D403AC
Public Function getComboBoxListIndex(cmb As ComboBox, ByVal sItemData As String) As Long
    Dim iIndex As Integer
    
    getComboBoxListIndex = 0
    For iIndex = 0 To cmb.ListCount - 1
        If cmb.List(iIndex) = sItemData Then
            getComboBoxListIndex = cmb.ItemData(iIndex)
            Exit Function
        End If
    Next iIndex
End Function
'Return the text value for a combo box given an item index
'##ModelId=370003D403AF
Public Function getComboBoxListValue(cmb As ComboBox, ByVal lItemData As Long) As String
    Dim iIndex As Integer
    
    getComboBoxListValue = gsBLANKSTRING
    For iIndex = 0 To cmb.ListCount - 1
        If cmb.ItemData(iIndex) = lItemData Then
            getComboBoxListValue = cmb.List(iIndex)
            Exit For
        End If
    Next iIndex
End Function
'Remove an item from a list box
'##ModelId=370003D403DF
Public Sub removeItemFromListBox(sItem As String, lstItem As ListBox)
    Dim iIndex As Integer
    For iIndex = 0 To lstItem.ListCount - 1
        If lstItem.List(iIndex) = sItem Then
            lstItem.RemoveItem iIndex
            Exit For
        End If
    Next
End Sub
'Remove all items from a list box
'##ModelId=370003D50032
Public Sub removeAllItemsFromListBox(lstItem As ListBox)
    Dim iIndex As Integer
    For iIndex = lstItem.ListCount - 1 To 0 Step -1
        
        lstItem.RemoveItem iIndex
           
    Next
End Sub
'Remove an Item from a Collection by Key
'##ModelId=370003D50034
Public Sub removeFromCollection(colTemp As Collection, ByVal sItem As String)
    On Error GoTo removeFromCollectionErr
    colTemp.Remove sItem
    Exit Sub
removeFromCollectionErr:
End Sub
